
                        .FILE     C:\PROJEKTE\MC-HX\SOFTWARE\AVRCO\MC-HX2561\CPULOADER\CPULOADER.pas

                        ; Compiled by E-LAB AVRco PASCAL Compiler Rev 5.04.06
                        ; Version     : Profi
                        ;
                        ; Licenced to : MB-DataTec GmbH
                        ;
                        ; (c)E-LAB Computers, Grombacherstr. 27  e-mail info@e-lab.de
                        ; D-74906 Bad Rappenau  Tel. 07268/9124-0 Fax. 07268/9124-24
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Source File : CPULOADER.pas
                        ; Compiled    : 11. September 2012  14:41:38
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                        .LARGE
                        .ROMEND         3FFFFh;
                        .EEPROMEND      00FFFh;

                        .BOOTAPP
                        .FLASHCHECKEND  3FFFEh
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Constants and Variables definition
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


                        ; === Internal used memory and constants ===

FALSE                   .EQU    000h            ; const 
TRUE                    .EQU    0FFh            ; const 
NIL                     .EQU    000h            ; const 
PI                      .EQU    000h            ; const 
COMPILERREV             .EQU    1F8h            ; const 
COMPILERBUILD_Y         .EQU    00Ch            ; const 
COMPILERBUILD_M         .EQU    008h            ; const 
COMPILERBUILD_D         .EQU    005h            ; const 
COMPILEYEAR             .EQU    00Ch            ; const 
COMPILEMONTH            .EQU    009h            ; const 
COMPILEDAY              .EQU    00Bh            ; const 
COMPILEHOUR             .EQU    00Eh            ; const 
COMPILEMINUTE           .EQU    029h            ; const 
PROJECTBUILD            .EQU    003h            ; const 
OPTIMISERREV            .EQU      0301h         ; const
OPTIMISERBUILD          .EQU      0103h         ; const
INTFLAG                 .EQU    007h            ; const 
_EEPROM                 .EQU    006h            ; const 
_SIGN                   .EQU    005h            ; const 
_WAITLCD                .EQU    004h            ; const 
_STRCONST               .EQU    004h            ; const 
_DEVICE                 .EQU    003h            ; const 
_NEGATIVE               .EQU    002h            ; const 
_ERRFLAG                .EQU    001h            ; const 
_I2C2BYTE               .EQU    000h            ; const 
_TOGGLE300              .EQU    000h            ; const 
_LCDLOWER               .EQU    001h            ; const 
_DSP7RFR                .EQU    002h            ; const 
_PWRSAVFLG              .EQU    003h            ; const 
_F64StrInt              .EQU    004h            ; const 
_F64StrFrac             .EQU    005h            ; const 
_FREQCNTFLAG            .EQU    006h            ; const 
_AUTOACK                .EQU    007h            ; const 
_ACCGLO                 .EQU    000h            ; var Data   byte
_ACCGHI                 .EQU    001h            ; var Data   byte
_ACCHLO                 .EQU    002h            ; var Data   byte
_ACCHHI                 .EQU    003h            ; var Data   byte
_ACCB                   .EQU    010h            ; var Data   byte
_ACCA                   .EQU    011h            ; var Data   byte
_ACCALO                 .EQU    012h            ; var Data   byte
_ACCAHI                 .EQU    013h            ; var Data   byte
_ACCDLO                 .EQU    014h            ; var Data   byte
_ACCDHI                 .EQU    015h            ; var Data   byte
_ACCELO                 .EQU    016h            ; var Data   byte
_ACCEHI                 .EQU    017h            ; var Data   byte
_ACCFLO                 .EQU    018h            ; var Data   byte
_ACCFHI                 .EQU    019h            ; var Data   byte
_ACCBLO                 .EQU    01Ah            ; var Data   byte
_ACCBHI                 .EQU    01Bh            ; var Data   byte
_FRAMEPTR               .EQU    01Ch            ; var Data   byte
_FPTRHI                 .EQU    01Dh            ; var Data   byte
_ACCCLO                 .EQU    01Eh            ; var Data   byte
_ACCCHI                 .EQU    01Fh            ; var Data   byte
FLAGS                   .EQU    004h            ; var Data   byte
FLAGS2                  .EQU    005h            ; var Data   byte
PROCCLOCK               .EQU    0E10000h        ; const 
DECIMALSEP              .EQU    02Eh            ; const 
CPU_ID                  .EQU    1E9802h         ; const 
Flash_Page_Size         .EQU    100h            ; const 
ROMconstPage            .EQU    0FFFFFFFFFFFFFFFFh          ; const 
STACKSIZE               .EQU    200h            ; const 
FRAMESIZE               .EQU    200h            ; const 
UDR3                    .EQU    136h            ; var iData  byte
UBRR3H                  .EQU    135h            ; var iData  byte
UBRR3L                  .EQU    134h            ; var iData  byte
UCSR3C                  .EQU    132h            ; var iData  byte
UCSR3B                  .EQU    131h            ; var iData  byte
UCSR3A                  .EQU    130h            ; var iData  byte
OCR5CH                  .EQU    12Dh            ; var iData  byte
OCR5CL                  .EQU    12Ch            ; var iData  byte
OCR5BH                  .EQU    12Bh            ; var iData  byte
OCR5BL                  .EQU    12Ah            ; var iData  byte
OCR5AH                  .EQU    129h            ; var iData  byte
OCR5AL                  .EQU    128h            ; var iData  byte
ICR5H                   .EQU    127h            ; var iData  byte
ICR5L                   .EQU    126h            ; var iData  byte
TCNT5H                  .EQU    125h            ; var iData  byte
TCNT5L                  .EQU    124h            ; var iData  byte
TCCR5C                  .EQU    122h            ; var iData  byte
TCCR5B                  .EQU    121h            ; var iData  byte
TCCR5A                  .EQU    120h            ; var iData  byte
PORTL                   .EQU    10Bh            ; var iData  byte
DDRL                    .EQU    10Ah            ; var iData  byte
PINL                    .EQU    109h            ; var iData  byte
PORTK                   .EQU    108h            ; var iData  byte
DDRK                    .EQU    107h            ; var iData  byte
PINK                    .EQU    106h            ; var iData  byte
PORTJ                   .EQU    105h            ; var iData  byte
DDRJ                    .EQU    104h            ; var iData  byte
PINJ                    .EQU    103h            ; var iData  byte
PORTH                   .EQU    102h            ; var iData  byte
DDRH                    .EQU    101h            ; var iData  byte
PINH                    .EQU    100h            ; var iData  byte
UDR2                    .EQU    0D6h            ; var iData  byte
UBRR2H                  .EQU    0D5h            ; var iData  byte
UBRR2L                  .EQU    0D4h            ; var iData  byte
UCSR2C                  .EQU    0D2h            ; var iData  byte
UCSR2B                  .EQU    0D1h            ; var iData  byte
UCSR2A                  .EQU    0D0h            ; var iData  byte
UDR1                    .EQU    0CEh            ; var iData  byte
UBRR1H                  .EQU    0CDh            ; var iData  byte
UBRR1L                  .EQU    0CCh            ; var iData  byte
UCSR1C                  .EQU    0CAh            ; var iData  byte
UCSR1B                  .EQU    0C9h            ; var iData  byte
UCSR1A                  .EQU    0C8h            ; var iData  byte
UDR0                    .EQU    0C6h            ; var iData  byte
UBRR0H                  .EQU    0C5h            ; var iData  byte
UBRR0L                  .EQU    0C4h            ; var iData  byte
UCSR0C                  .EQU    0C2h            ; var iData  byte
UCSR0B                  .EQU    0C1h            ; var iData  byte
UCSR0A                  .EQU    0C0h            ; var iData  byte
TWAMR                   .EQU    0BDh            ; var iData  byte
TWCR                    .EQU    0BCh            ; var iData  byte
TWDR                    .EQU    0BBh            ; var iData  byte
TWAR                    .EQU    0BAh            ; var iData  byte
TWSR                    .EQU    0B9h            ; var iData  byte
TWBR                    .EQU    0B8h            ; var iData  byte
ASSR                    .EQU    0B6h            ; var iData  byte
OCR2B                   .EQU    0B4h            ; var iData  byte
OCR2                    .EQU    0B3h            ; var iData  byte
OCR2A                   .EQU    0B3h            ; var iData  byte
TCNT2                   .EQU    0B2h            ; var iData  byte
TCCR2B                  .EQU    0B1h            ; var iData  byte
TCCR2                   .EQU    0B1h            ; var iData  byte
TCCR2A                  .EQU    0B0h            ; var iData  byte
OCR4CH                  .EQU    0ADh            ; var iData  byte
OCR4CL                  .EQU    0ACh            ; var iData  byte
OCR4BH                  .EQU    0ABh            ; var iData  byte
OCR4BL                  .EQU    0AAh            ; var iData  byte
OCR4AH                  .EQU    0A9h            ; var iData  byte
OCR4AL                  .EQU    0A8h            ; var iData  byte
ICR4H                   .EQU    0A7h            ; var iData  byte
ICR4L                   .EQU    0A6h            ; var iData  byte
TCNT4H                  .EQU    0A5h            ; var iData  byte
TCNT4L                  .EQU    0A4h            ; var iData  byte
TCCR4C                  .EQU    0A2h            ; var iData  byte
TCCR4B                  .EQU    0A1h            ; var iData  byte
TCCR4A                  .EQU    0A0h            ; var iData  byte
OCR3CH                  .EQU    09Dh            ; var iData  byte
OCR3CL                  .EQU    09Ch            ; var iData  byte
OCR3BH                  .EQU    09Bh            ; var iData  byte
OCR3BL                  .EQU    09Ah            ; var iData  byte
OCR3AH                  .EQU    099h            ; var iData  byte
OCR3AL                  .EQU    098h            ; var iData  byte
ICR3H                   .EQU    097h            ; var iData  byte
ICR3L                   .EQU    096h            ; var iData  byte
TCNT3H                  .EQU    095h            ; var iData  byte
TCNT3L                  .EQU    094h            ; var iData  byte
TCCR3C                  .EQU    092h            ; var iData  byte
TCCR3B                  .EQU    091h            ; var iData  byte
TCCR3A                  .EQU    090h            ; var iData  byte
OCR1CH                  .EQU    08Dh            ; var iData  byte
OCR1CL                  .EQU    08Ch            ; var iData  byte
OCR1BH                  .EQU    08Bh            ; var iData  byte
OCR1BL                  .EQU    08Ah            ; var iData  byte
OCR1AH                  .EQU    089h            ; var iData  byte
OCR1AL                  .EQU    088h            ; var iData  byte
ICR1H                   .EQU    087h            ; var iData  byte
ICR1L                   .EQU    086h            ; var iData  byte
TCNT1H                  .EQU    085h            ; var iData  byte
TCNT1L                  .EQU    084h            ; var iData  byte
TCCR1C                  .EQU    082h            ; var iData  byte
TCCR1B                  .EQU    081h            ; var iData  byte
TCCR1A                  .EQU    080h            ; var iData  byte
DIDR1                   .EQU    07Fh            ; var iData  byte
DIDR0                   .EQU    07Eh            ; var iData  byte
DIDR2                   .EQU    07Dh            ; var iData  byte
ADMUX                   .EQU    07Ch            ; var iData  byte
ADCSRB                  .EQU    07Bh            ; var iData  byte
ADCSR                   .EQU    07Ah            ; var iData  byte
ADCSRA                  .EQU    07Ah            ; var iData  byte
ADCH                    .EQU    079h            ; var iData  byte
ADCL                    .EQU    078h            ; var iData  byte
XMCRB                   .EQU    075h            ; var iData  byte
XMCRA                   .EQU    074h            ; var iData  byte
TIMSK5                  .EQU    073h            ; var iData  byte
TIMSK4                  .EQU    072h            ; var iData  byte
TIMSK3                  .EQU    071h            ; var iData  byte
TIMSK2                  .EQU    070h            ; var iData  byte
TIMSK1                  .EQU    06Fh            ; var iData  byte
TIMSK0                  .EQU    06Eh            ; var iData  byte
PCMSK2                  .EQU    06Dh            ; var iData  byte
PCMSK1                  .EQU    06Ch            ; var iData  byte
PCMSK0                  .EQU    06Bh            ; var iData  byte
EICRB                   .EQU    06Ah            ; var iData  byte
EICRA                   .EQU    069h            ; var iData  byte
PCICR                   .EQU    068h            ; var iData  byte
OSCCAL                  .EQU    066h            ; var iData  byte
PRR1                    .EQU    065h            ; var iData  byte
PRR0                    .EQU    064h            ; var iData  byte
CLKPR                   .EQU    061h            ; var iData  byte
WDTCR                   .EQU    060h            ; var iData  byte
WDTCSR                  .EQU    060h            ; var iData  byte
SREG                    .EQU    05Fh            ; var pData  byte
SPH                     .EQU    05Eh            ; var pData  byte
SPL                     .EQU    05Dh            ; var pData  byte
EIND                    .EQU    05Ch            ; var pData  byte
RAMPZ                   .EQU    05Bh            ; var pData  byte
SPMCSR                  .EQU    057h            ; var pData  byte
SPMCR                   .EQU    057h            ; var pData  byte
MCUCR                   .EQU    055h            ; var pData  byte
MCUCSR                  .EQU    054h            ; var pData  byte
MCUSR                   .EQU    054h            ; var pData  byte
SMCR                    .EQU    053h            ; var pData  byte
OCDR                    .EQU    051h            ; var pData  byte
MONDR                   .EQU    051h            ; var pData  byte
ACSR                    .EQU    050h            ; var pData  byte
SPDR                    .EQU    04Eh            ; var pData  byte
SPSR                    .EQU    04Dh            ; var pData  byte
SPCR                    .EQU    04Ch            ; var pData  byte
GPIOR2                  .EQU    04Bh            ; var pData  byte
GPIOR1                  .EQU    04Ah            ; var pData  byte
OCR0B                   .EQU    048h            ; var pData  byte
OCR0                    .EQU    047h            ; var pData  byte
OCR0A                   .EQU    047h            ; var pData  byte
TCNT0                   .EQU    046h            ; var pData  byte
TCCR0B                  .EQU    045h            ; var pData  byte
TCCR0                   .EQU    045h            ; var pData  byte
TCCR0A                  .EQU    044h            ; var pData  byte
GTCCR                   .EQU    043h            ; var pData  byte
EEARH                   .EQU    042h            ; var pData  byte
EEARL                   .EQU    041h            ; var pData  byte
EEDR                    .EQU    040h            ; var pData  byte
EECR                    .EQU    03Fh            ; var pData  byte
GPIOR0                  .EQU    03Eh            ; var pData  byte
EIMSK                   .EQU    03Dh            ; var pData  byte
EIFR                    .EQU    03Ch            ; var pData  byte
PCIFR                   .EQU    03Bh            ; var pData  byte
TIFR5                   .EQU    03Ah            ; var pData  byte
TIFR4                   .EQU    039h            ; var pData  byte
TIFR3                   .EQU    038h            ; var pData  byte
TIFR2                   .EQU    037h            ; var pData  byte
TIFR1                   .EQU    036h            ; var pData  byte
TIFR0                   .EQU    035h            ; var pData  byte
PORTG                   .EQU    034h            ; var pData  byte
DDRG                    .EQU    033h            ; var pData  byte
PING                    .EQU    032h            ; var pData  byte
PORTF                   .EQU    031h            ; var pData  byte
DDRF                    .EQU    030h            ; var pData  byte
PINF                    .EQU    02Fh            ; var pData  byte
PORTE                   .EQU    02Eh            ; var pData  byte
DDRE                    .EQU    02Dh            ; var pData  byte
PINE                    .EQU    02Ch            ; var pData  byte
PORTD                   .EQU    02Bh            ; var pData  byte
DDRD                    .EQU    02Ah            ; var pData  byte
PIND                    .EQU    029h            ; var pData  byte
PORTC                   .EQU    028h            ; var pData  byte
DDRC                    .EQU    027h            ; var pData  byte
PINC                    .EQU    026h            ; var pData  byte
PORTB                   .EQU    025h            ; var pData  byte
DDRB                    .EQU    024h            ; var pData  byte
PINB                    .EQU    023h            ; var pData  byte
PORTA                   .EQU    022h            ; var pData  byte
DDRA                    .EQU    021h            ; var pData  byte
PINA                    .EQU    020h            ; var pData  byte
TCNT5                   .EQU    124h            ; var iData  word
OCR5A                   .EQU    128h            ; var iData  word
OCR5B                   .EQU    12Ah            ; var iData  word
OCR5C                   .EQU    12Ch            ; var iData  word
ICR5                    .EQU    126h            ; var iData  word
TCNT4                   .EQU    0A4h            ; var iData  word
OCR4A                   .EQU    0A8h            ; var iData  word
OCR4B                   .EQU    0AAh            ; var iData  word
OCR4C                   .EQU    0ACh            ; var iData  word
ICR4                    .EQU    0A6h            ; var iData  word
TCNT3                   .EQU    094h            ; var iData  word
OCR3A                   .EQU    098h            ; var iData  word
OCR3B                   .EQU    09Ah            ; var iData  word
OCR3C                   .EQU    09Ch            ; var iData  word
ICR3                    .EQU    096h            ; var iData  word
OCR1C                   .EQU    08Ch            ; var iData  word
TCNT1                   .EQU    084h            ; var iData  word
OCR1A                   .EQU    088h            ; var iData  word
OCR1B                   .EQU    08Ah            ; var iData  word
ICR1                    .EQU    086h            ; var iData  word
EEAR                    .EQU    041h            ; var pData  word
ADC                     .EQU    078h            ; var iData  word
_iDataStart             .EQU    200h            ; const 
_iDataEnd               .EQU    21FFh           ; const 
_EEpromStart            .EQU    000h            ; const 
_EEpromEnd              .EQU    0FFFh           ; const 
_FlashStart             .EQU    000h            ; const 
_FlashEnd               .EQU    3FFFFh          ; const 
BootEntry               .EQU    3F000h          ; const 
FLASH_ADDR              .EQU    200h            ; var iData  word
FLASH_PAGE              .EQU    202h            ; var iData  byte
FlashBuffer             .EQU    203h            ; var iData  array
_CalcFlashCS            .EQU    303h            ; var iData  word
_CalcFlashAddr          .EQU    305h            ; var iData  word
_CalcFlashPage          .EQU    307h            ; var iData  byte
EEPROM                  .EQU    000h            ; var EEprom array
EEPROMEND               .EQU    0FFFh           ; const 



                        .RESET     03F000h
                        .ORG       03F000h, CODE_START
                        .STARTCODE 03F0E4h


                        .FILE     MMCLoader.pas
                        .UNIT   MMCLoader

                        ; ============ user definitions module: MMCLoader ============

MMCLoader.Boot_Start    .EQU    00003F000h      ; const longWord 258048
MMCLoader.Boot_End      .EQU    000040000h      ; const longWord 262144
;UPDFilename             .EQU    'CPU.BIN'; const String
;UPDNAME                 .EQU    'CPU     '; const String
                        .SYM      gMinPrevVersion, 00308h, 0000Eh, 3
MMCLoader.gMinPrevVersion     .EQU              308h        ; var iData  word
                        .SYM      gFileVersion, 0030Ah, 0000Eh, 3
MMCLoader.gFileVersion  .EQU    30Ah            ; var iData  word
                        .SYM      gFileCheckSum, 0030Ch, 0000Eh, 3
MMCLoader.gFileCheckSum .EQU    30Ch            ; var iData  word
MMCLoader.DOUBLESPEED   .EQU    000h            ; const boolean  false
MMCLoader.SPIINITCLOCK  .EQU    053h            ; const byte     83
MMCLoader.SPIREADCLOCK  .EQU    050h            ; const byte     80
MMCLoader.SPIWRITECLOCK .EQU    052h            ; const byte     82
                        .SYM      SDDummy, 0030Eh, 0000Dh, 3
MMCLoader.SDDummy       .EQU    30Eh            ; var iData  byte
                        .SYM      buffer, 0030Fh, 0003Dh, 3
MMCLoader.buffer        .EQU    30Fh            ; var iData  array
                        .SYM      flash, 0030Fh, 0003Eh, 3
MMCLoader.flash         .EQU    30Fh            ; var iData  array
                        .SYM      Dir, 0030Fh, 00038h, 3
MMCLoader.Dir           .EQU    30Fh            ; var iData  array
                        .SYM      FlashAdr, 0050Fh, 0000Eh, 3
MMCLoader.FlashAdr      .EQU    50Fh            ; var iData  word
                        .SYM      FlashPage, 00511h, 0000Dh, 3
MMCLoader.FlashPage     .EQU    511h            ; var iData  byte
                        .SYM      WordsWritten, 00512h, 0000Fh, 3
MMCLoader.WordsWritten  .EQU    512h            ; var iData  longword
                        .SYM      PTI_StartSector, 00516h, 0000Fh, 3
MMCLoader.PTI_StartSector     .EQU              516h        ; var iData  longword
                        .SYM      BPB_SecPerCluster, 0051Ah, 0000Dh, 3
MMCLoader.BPB_SecPerCluster   .EQU              51Ah        ; var iData  byte
                        .SYM      BPB_RsvdSecCnt, 0051Bh, 0000Eh, 3
MMCLoader.BPB_RsvdSecCnt      .EQU              51Bh        ; var iData  word
                        .SYM      BPB_NumFATs, 0051Dh, 0000Dh, 3
MMCLoader.BPB_NumFATs   .EQU    51Dh            ; var iData  byte
                        .SYM      BPB_FatSz, 0051Eh, 0000Eh, 3
MMCLoader.BPB_FatSz     .EQU    51Eh            ; var iData  word
                        .SYM      FAT_RootDir, 00520h, 0000Fh, 3
MMCLoader.FAT_RootDir   .EQU    520h            ; var iData  longword
                        .SYM      FAT_StartData, 00524h, 0000Fh, 3
MMCLoader.FAT_StartData .EQU    524h            ; var iData  longword
                        .SYM      FAT_StartFAT, 00528h, 0000Fh, 3
MMCLoader.FAT_StartFAT  .EQU    528h            ; var iData  longword
                        .SYM      FirstCluster, 0052Ch, 0000Eh, 3
MMCLoader.FirstCluster  .EQU    52Ch            ; var iData  word
                        .SYM      NextCluster, 0052Eh, 0000Eh, 3
MMCLoader.NextCluster   .EQU    52Eh            ; var iData  word
MMCLoader.BPB_BytesPerSec     .EQU              00200h      ; const word     512
MMCLoader.SECTOR_SIZE   .EQU    00200h          ; const word     512
MMCLoader.FAT_RootDirSecs     .EQU              00020h      ; const word     32
                        .FUNC     GetFileVersionAndCheckSum, 00085h, 00020h
MMCLoader.GetFileVersionAndCheckSum:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 16
                        .BLOCK    141
                        .LINE     142
                        .BRANCH   17,MMCLoader.FINDFIRSTCLUSTER
                        RCALL     MMCLoader.FINDFIRSTCLUSTER
                        ADIW      _FRAMEPTR, 4

                        COM       _ACCA
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0000
                        BREQ      MMCLoader._L0000
                        .BLOCK    143
                        .LINE     143
                        LDI       _ACCA, 000h
                        .BRANCH   20,MMCLoader.GetFileVersionAndCheckSum_X
                        RJMP      MMCLoader.GetFileVersionAndCheckSum_X
                        .ENDBLOCK 144
MMCLoader._L0000:
                        .LINE     145
                        LDI       _ACCA, 00000h SHRB 8
                        LDI       _ACCB, 00000h AND 0FFh
                        STD       Y+00Ah, _ACCA
                        STD       Y+009h, _ACCB
                        .LINE     146
                        LDI       _ACCALO, 000000000h SHRB 16
                        LDI       _ACCAHI, 000000000h SHRB 24
                        STD       Y+006h, _ACCAHI
                        STD       Y+005h, _ACCALO
                        STD       Y+004h, _ACCA
                        STD       Y+003h, _ACCB
                        .LINE     147
                        LDS       _ACCB, MMCLoader.FirstCluster
                        LDS       _ACCA, MMCLoader.FirstCluster+1
                        STS       MMCLOADER.NEXTCLUSTER, _ACCB
                        STS       MMCLOADER.NEXTCLUSTER+1, _ACCA
MMCLoader._L0003:
                        .BLOCK    148
                        .LINE     149
                        LDS       _ACCB, MMCLoader.BPB_SecPerCluster
                        CLR       _ACCA
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        PUSH      _ACCB
                        PUSH      _ACCA
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
                        LDS       _ACCB, MMCLoader.NextCluster
                        LDS       _ACCA, MMCLoader.NextCluster+1
                        SUBI      _ACCB, 00002h AND 0FFh
                        SBCI      _ACCA, 00002h SHRB 8
                        CLT
                        BLD       Flags, _SIGN
                        RCALL     SYSTEM.MUL32
                        MOVW      _ACCBLO, _ACCB
                        MOVW      _ACCCLO, _ACCALO
                        LDS       _ACCB, MMCLoader.FAT_StartData
                        LDS       _ACCA, MMCLoader.FAT_StartData+1
                        LDS       _ACCALO, MMCLoader.FAT_StartData+2
                        LDS       _ACCAHI, MMCLoader.FAT_StartData+3
                        ADD       _ACCB, _ACCBLO
                        ADC       _ACCA, _ACCBHI
                        ADC       _ACCALO, _ACCCLO
                        ADC       _ACCAHI, _ACCCHI
                        STD       Y+00Eh, _ACCAHI
                        STD       Y+00Dh, _ACCALO
                        STD       Y+00Ch, _ACCA
                        STD       Y+00Bh, _ACCB
                        .LINE     150
                        LDI       _ACCA, 001h
                        STD       Y+00Fh, _ACCA
                        .LINE     151
MMCLoader._L0006:
                        LDD       _ACCB, Y+00Fh
                        LDS       _ACCA, MMCLoader.BPB_SecPerCluster
                        CP        _ACCB, _ACCA
                        .BRANCH   1, MMCLoader._L0009
                        BRLO      MMCLoader._L0009
                        .BRANCH   3, MMCLoader._L0009
                        BREQ      MMCLoader._L0009
                        .BRANCH   20,MMCLoader._L0007
                        RJMP      MMCLoader._L0007
MMCLoader._L0009:
                        .BLOCK    152
                        .LINE     152
                        LDD       _ACCAHI, Y+00Eh
                        LDD       _ACCALO, Y+00Dh
                        LDD       _ACCA, Y+00Ch
                        LDD       _ACCB, Y+00Bh
                        ST        -Y, _ACCAHI
                        ST        -Y, _ACCALO
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  4
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCREADSECTOR
                        RCALL     MMCLoader.MMCREADSECTOR
                        ADIW      _FRAMEPTR, 7

                        TST       _ACCA
                        .BRANCH   4,MMCLoader._L0012
                        BRNE      MMCLoader._L0012
                        .BRANCH   20,MMCLoader._L0010
                        RJMP      MMCLoader._L0010
MMCLoader._L0012:
                        .BLOCK    153
                        .LINE     153
                        LDI       _ACCA, 00000h SHRB 8
                        LDI       _ACCB, 00000h AND 0FFh
                        STD       Y+008h, _ACCA
                        STD       Y+007h, _ACCB
                        .LINE     154
MMCLoader._L0013:
                        LDD       _ACCB, Y+007h
                        LDD       _ACCA, Y+008h
                        CPI       _ACCA, 001h
                        BRNE      MMCLoader._L0015
                        CPI       _ACCB, 0FFh
MMCLoader._L0015:
                        .BRANCH   1, MMCLoader._L0017
                        BRLO      MMCLoader._L0017
                        .BRANCH   3, MMCLoader._L0017
                        BREQ      MMCLoader._L0017
                        .BRANCH   20,MMCLoader._L0014
                        RJMP      MMCLoader._L0014
MMCLoader._L0017:
                        .BLOCK    155
                        .LINE     155
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000003h
                        LD        _ACCBLO, Z
                        LDD       _ACCBHI, Z+1
                        LDD       _ACCFLO, Z+2
                        LDD       _ACCFHI, Z+3
                        ADIW      _ACCBLO, 1
                        BRCC      MMCLoader._L0018
                        ADIW      _ACCFLO, 1
MMCLoader._L0018:
                        ST        Z, _ACCBLO
                        STD       Z+1, _ACCBHI
                        STD       Z+2, _ACCFLO
                        STD       Z+3, _ACCFHI
                        .LINE     156
                        LDD       _ACCAHI, Y+006h
                        LDD       _ACCALO, Y+005h
                        LDD       _ACCA, Y+004h
                        LDD       _ACCB, Y+003h
                        CPI       _ACCAHI, 000h
                        BRNE      MMCLoader._L0019
                        CPI       _ACCALO, 003h
                        BRNE      MMCLoader._L0019
                        CPI       _ACCA, 0EFh
                        BRNE      MMCLoader._L0019
                        CPI       _ACCB, 0FFh
MMCLoader._L0019:
                        .BRANCH   2, MMCLoader._L0021
                        BRSH      MMCLoader._L0021
                        .BLOCK    157
                        .LINE     157
                        LDD       _ACCALO, Y+009h
                        LDD       _ACCAHI, Y+00Ah
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        LDD       _ACCB, Y+007h
                        LDD       _ACCA, Y+008h
                        ADD       _ACCCLO, _ACCB
                        ADC       _ACCCHI, _ACCA
                        LD        _ACCB, Z+
                        CLR       _ACCA
                        ADD       _ACCB, _ACCALO
                        ADC       _ACCA, _ACCAHI
                        STD       Y+00Ah, _ACCA
                        STD       Y+009h, _ACCB
                        .ENDBLOCK 159
                        .BRANCH   20,MMCLoader._L0022
                        RJMP      MMCLoader._L0022
MMCLoader._L0021:
                        .BLOCK    159
                        .LINE     159
                        LDD       _ACCAHI, Y+006h
                        LDD       _ACCALO, Y+005h
                        LDD       _ACCA, Y+004h
                        LDD       _ACCB, Y+003h
                        CPI       _ACCAHI, 000h
                        BRNE      MMCLoader._L0024
                        CPI       _ACCALO, 003h
                        BRNE      MMCLoader._L0024
                        CPI       _ACCA, 0EFh
                        BRNE      MMCLoader._L0024
                        CPI       _ACCB, 0FFh
MMCLoader._L0024:
                        .BRANCH   4, MMCLoader._L0026
                        BRNE      MMCLoader._L0026
                        .BLOCK    160
                        .LINE     160
                        LDI       _ACCCLO, MMCLoader.flash AND 0FFh
                        LDI       _ACCCHI, MMCLoader.flash SHRB 8
                        SUBI      _ACCCLO, -001F8h AND 0FFh
                        SBCI      _ACCCHI, -001F8h SHRB 8
                        LD        _ACCB, Z+
                        LD        _ACCA, Z+
                        STS       MMCLOADER.GMINPREVVERSION, _ACCB
                        STS       MMCLOADER.GMINPREVVERSION+1, _ACCA
                        .LINE     161
                        LDI       _ACCCLO, MMCLoader.flash AND 0FFh
                        LDI       _ACCCHI, MMCLoader.flash SHRB 8
                        SUBI      _ACCCLO, -001FAh AND 0FFh
                        SBCI      _ACCCHI, -001FAh SHRB 8
                        LD        _ACCB, Z+
                        LD        _ACCA, Z+
                        STS       MMCLOADER.GFILEVERSION, _ACCB
                        STS       MMCLOADER.GFILEVERSION+1, _ACCA
                        .LINE     162
                        LDI       _ACCCLO, MMCLoader.flash AND 0FFh
                        LDI       _ACCCHI, MMCLoader.flash SHRB 8
                        SUBI      _ACCCLO, -001FEh AND 0FFh
                        SBCI      _ACCCHI, -001FEh SHRB 8
                        LD        _ACCB, Z+
                        LD        _ACCA, Z+
                        STS       MMCLOADER.GFILECHECKSUM, _ACCB
                        STS       MMCLOADER.GFILECHECKSUM+1, _ACCA
                        .ENDBLOCK 163
MMCLoader._L0026:
                        .ENDBLOCK 164
MMCLoader._L0022:
                        .LINE     165
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000007h
                        LD        _ACCBLO, Z
                        LDD       _ACCBHI, Z+1
                        ADIW      _ACCBLO, 1
                        ST        Z, _ACCBLO
                        STD       Z+1, _ACCBHI
                        .ENDBLOCK 166
                        .LINE     166
                        .BRANCH   20,MMCLoader._L0013
                        RJMP      MMCLoader._L0013
MMCLoader._L0014:
                        .ENDBLOCK 167
MMCLoader._L0010:
                        .LINE     168
                        LDD       _ACCAHI, Y+00Eh
                        LDD       _ACCALO, Y+00Dh
                        LDD       _ACCA, Y+00Ch
                        LDD       _ACCB, Y+00Bh
                        SUBI      _ACCB, -000000001h AND 0FFh
                        SBCI      _ACCA, -000000001h SHRB 8
                        SBCI      _ACCALO, -000000001h SHRB 16
                        SBCI      _ACCAHI, -000000001h SHRB 24
                        STD       Y+00Eh, _ACCAHI
                        STD       Y+00Dh, _ACCALO
                        STD       Y+00Ch, _ACCA
                        STD       Y+00Bh, _ACCB
                        .LINE     169
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 00000Fh
                        LD        _ACCA, Z
                        INC       _ACCA
                        ST        Z, _ACCA
                        .ENDBLOCK 170
                        .LINE     170
                        .BRANCH   20,MMCLoader._L0006
                        RJMP      MMCLoader._L0006
MMCLoader._L0007:
                        .ENDBLOCK 171
                        .LINE     171
                        .BRANCH   17,MMCLoader.FINDNEXTCLUSTER
                        RCALL     MMCLoader.FINDNEXTCLUSTER
                        ADIW      _FRAMEPTR, 10

                        COM       _ACCA
                        TST       _ACCA
                        .BRANCH   4,MMCLoader._L0029
                        BRNE      MMCLoader._L0029
                        .BRANCH   20,MMCLoader._L0003
                        RJMP      MMCLoader._L0003
MMCLoader._L0029:
                        .LINE     172
                        LDI       _ACCCLO, MMCLoader.BootFlag AND 0FFh
                        LDI       _ACCCHI, MMCLoader.BootFlag SHRB 8
                        ADIW      _ACCCLO, 00002h
                        LDI       _ACCB, 03h
                        OUT       RAMPZ, _ACCB
                        ELPM      _ACCB, Z+
                        ELPM      _ACCA, Z
                        STD       Y+001h, _ACCA
                        STD       Y+000h, _ACCB
                        .LINE     173
                        LDS       _ACCALO, MMCLoader.gFileCheckSum
                        LDS       _ACCAHI, MMCLoader.gFileCheckSum+1
                        LDD       _ACCA, Y+00Ah
                        LDD       _ACCB, Y+009h
                        CP        _ACCA, _ACCAHI
                        BRNE      MMCLoader._L0030
                        CP        _ACCB, _ACCALO
MMCLoader._L0030:
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0031
                        SER       _ACCA
MMCLoader._L0031:
                        PUSH      _ACCA
                        LDS       _ACCALO, MMCLoader.gMinPrevVersion
                        LDS       _ACCAHI, MMCLoader.gMinPrevVersion+1
                        LDD       _ACCA, Y+001h
                        LDD       _ACCB, Y+000h
                        CP        _ACCA, _ACCAHI
                        BRNE      MMCLoader._L0032
                        CP        _ACCB, _ACCALO
MMCLoader._L0032:
                        LDI       _ACCA, 0
                        BRLO      MMCLoader._L0033
                        LDI       _ACCA, 0FFh
MMCLoader._L0033:
                        PUSH      _ACCA
                        LDD       _ACCALO, Y+000h
                        LDD       _ACCAHI, Y+001h
                        LDS       _ACCA, MMCLoader.gFileVersion+1
                        LDS       _ACCB, MMCLoader.gFileVersion
                        CP        _ACCA, _ACCAHI
                        BRNE      MMCLoader._L0034
                        CP        _ACCB, _ACCALO
MMCLoader._L0034:
                        LDI       _ACCA, 0h
                        BREQ      MMCLoader._L0035
                        BRLO      MMCLoader._L0035
                        SER       _ACCA
MMCLoader._L0035:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        PUSH      _ACCA
                        LDD       _ACCB, Y+000h
                        LDD       _ACCA, Y+001h
                        CPI       _ACCA, 0FFh
                        BRNE      MMCLoader._L0036
                        CPI       _ACCB, 0FFh
MMCLoader._L0036:
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0037
                        SER       _ACCA
MMCLoader._L0037:
                        POP       _ACCB
                        OR        _ACCA, _ACCB
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        .ENDBLOCK 177
MMCLoader.GetFileVersionAndCheckSum_X:
                        .LINE     177
                        .BRANCH   19
                        RET
                        .ENDFUNC  177

                        .FUNC     UpdateFirmware, 000B8h, 00020h
MMCLoader.UpdateFirmware:
                        .RETURNS   0
                        .BLOCK    185
                        .LINE     186
                        CLI
                        LDI       _ACCCLO, MMCLoader.Bootflag AND 0FFh
                        LDI       _ACCCHI, MMCLoader.Bootflag SHRB 8
                        STS       FLASH_ADDR+1, _ACCCHI
                        STS       FLASH_ADDR, _ACCCLO
                        LDI       _ACCA, MMCLoader.Bootflag SHRB 16
                        STS       FLASH_PAGE, _ACCA
                        SBRC      Flags, IntFlag
                        SEI
                        .LINE     187
                        RCALL     SYSTEM.FLASHERASEPAGE

                        .LINE     188
                        LDI       _ACCA, 00000h SHRB 8
                        LDI       _ACCB, 00000h AND 0FFh
                        STS       MMCLOADER.FLASHADR, _ACCB
                        STS       MMCLOADER.FLASHADR+1, _ACCA
                        .LINE     189
                        STS       MMCLOADER.FLASHPAGE, _ACCA
                        .LINE     190
                        LDI       _ACCALO, 000000000h SHRB 16
                        LDI       _ACCAHI, 000000000h SHRB 24
                        STS       MMCLOADER.WORDSWRITTEN, _ACCB
                        STS       MMCLOADER.WORDSWRITTEN+1, _ACCA
                        STS       MMCLOADER.WORDSWRITTEN+2, _ACCALO
                        STS       MMCLOADER.WORDSWRITTEN+3, _ACCAHI
                        .LINE     191
                        LDS       _ACCB, MMCLoader.FirstCluster
                        LDS       _ACCA, MMCLoader.FirstCluster+1
                        STS       MMCLOADER.NEXTCLUSTER, _ACCB
                        STS       MMCLOADER.NEXTCLUSTER+1, _ACCA
                        .LINE     192
_CSE0000:                         
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        .BRANCH   17,MMCLoader.GETCLUSTER
                        RCALL     MMCLoader.GETCLUSTER
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     195
                        .LINE     193
MMCLoader._L0038:
                        .BRANCH   17,MMCLoader.FINDNEXTCLUSTER
                        RCALL     MMCLoader.FINDNEXTCLUSTER
                        ADIW      _FRAMEPTR, 10

                        TST       _ACCA
                        BRNE      _CSE0000
                        .BLOCK    193
                        .LINE     194

                        .ENDBLOCK 195
MMCLoader._L0039:
                        .ENDBLOCK 196
                        .LINE     196
                        .BRANCH   19
                        RET
                        .ENDFUNC  196

                        .FUNC     SPIPut, 000CBh, 00020h
MMCLoader.SPIPut:
                        .RETURNS   0
                        .BLOCK    204
                        .LINE     205
                        LDD       _ACCA, Y+000h
                        OUT       SPDR, _ACCA
MMCLoader._L0041:
                        .BLOCK    206
                        .ENDBLOCK 206
                        .LINE     206
                        IN        _ACCB, 04Dh
                        SBRS      _ACCB, 007h
                        .BRANCH   20,MMCLoader._L0041
                        RJMP      MMCLoader._L0041
                        .ENDBLOCK 207
                        .LINE     207
                        .BRANCH   19
                        RET
                        .ENDFUNC  207

                        .FUNC     SPIGet, 000D5h, 00020h
MMCLoader.SPIGet:
                        .RETURNS   1
                        .BLOCK    214
                        .LINE     215
                        LDI       _ACCA, 0FFh
                        OUT       SPDR, _ACCA
MMCLoader._L0045:
                        .BLOCK    216
                        .ENDBLOCK 216
                        .LINE     216
                        IN        _ACCB, 04Dh
                        SBRS      _ACCB, 007h
                        .BRANCH   20,MMCLoader._L0045
                        RJMP      MMCLoader._L0045
                        .LINE     217
                        IN        _ACCA, SPDR
                        .ENDBLOCK 218
                        .LINE     218
                        .BRANCH   19
                        RET
                        .ENDFUNC  218

                        .FUNC     MMCSendCmd, 000E0h, 00020h
MMCLoader.MMCSendCmd:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 3
                        .BLOCK    228
                        .LINE     229
                        LDI       _ACCA, 0FFh
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.SPIPUT
                        RCALL     MMCLoader.SPIPUT
                        ADIW      _FRAMEPTR, 1

                        .LINE     230
                        CBI       025h, 000h
                        .LINE     231
                        LDD       _ACCA, Y+008h
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.SPIPUT
                        RCALL     MMCLoader.SPIPUT
                        ADIW      _FRAMEPTR, 1

                        .LINE     232
                        LDD       _ACCA, Y+007h
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.SPIPUT
                        RCALL     MMCLoader.SPIPUT
                        ADIW      _FRAMEPTR, 1

                        .LINE     233
                        LDD       _ACCA, Y+006h
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.SPIPUT
                        RCALL     MMCLoader.SPIPUT
                        ADIW      _FRAMEPTR, 1

                        .LINE     234
                        LDD       _ACCA, Y+005h
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.SPIPUT
                        RCALL     MMCLoader.SPIPUT
                        ADIW      _FRAMEPTR, 1

                        .LINE     235
                        LDD       _ACCA, Y+004h
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.SPIPUT
                        RCALL     MMCLoader.SPIPUT
                        ADIW      _FRAMEPTR, 1

                        .LINE     236
                        LDD       _ACCA, Y+003h
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.SPIPUT
                        RCALL     MMCLoader.SPIPUT
                        ADIW      _FRAMEPTR, 1

                        .LINE     237
                        LDI       _ACCA, 00001h SHRB 8
                        LDI       _ACCB, 00001h AND 0FFh
                        STD       Y+001h, _ACCA
                        STD       Y+000h, _ACCB
                        .LINE     238
MMCLoader._L0049:
                        LDD       _ACCB, Y+000h
                        LDD       _ACCA, Y+001h
                        CPI       _ACCA, 01Fh
                        BRNE      MMCLoader._L0051
                        CPI       _ACCB, 0FFh
MMCLoader._L0051:
                        .BRANCH   1, MMCLoader._L0053
                        BRLO      MMCLoader._L0053
                        .BRANCH   4, MMCLoader._L0050
                        BRNE      MMCLoader._L0050
MMCLoader._L0053:
                        .BLOCK    238
                        .LINE     239
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        STD       Y+002h, _ACCA
                        .LINE     240
                        CPI       _ACCA, 0FFh
                        .BRANCH   4, MMCLoader._L0050
                        BRNE      MMCLoader._L0050
                        .BRANCH   20,MMCLoader._L0055
                        .BLOCK    240
                        .ENDBLOCK 242
                        .LINE     243
                        MOVW      _ACCCLO, _FRAMEPTR
                        LD        _ACCBLO, Z
                        LDD       _ACCBHI, Z+1
                        ADIW      _ACCBLO, 1
                        ST        Z, _ACCBLO
                        STD       Z+1, _ACCBHI
                        .ENDBLOCK 244
                        .LINE     244
                        .BRANCH   20,MMCLoader._L0049
                        RJMP      MMCLoader._L0049
MMCLoader._L0050:
                        .LINE     245
                        LDD       _ACCA, Y+002h
                        .ENDBLOCK 246
                        .LINE     246
                        .BRANCH   19
                        RET
                        .ENDFUNC  246

                        .FUNC     MMCInit, 000FCh, 00020h
MMCLoader.MMCInit:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 4
                        .BLOCK    257
                        .LINE     258
                        SBI       025h, 000h
                        .LINE     260
                        SBI       024h, 000h
                        .LINE     261
                        SBI       024h, 001h
                        .LINE     262
                        SBI       024h, 002h
                        .LINE     263
                        CBI       024h, 000h
                        .LINE     264
                        CBI       024h, 001h
                        .LINE     265
                        CBI       024h, 002h
                        .LINE     266
                        SBI       024h, 000h
                        .LINE     267
                        SBI       024h, 001h
                        .LINE     268
                        SBI       024h, 002h
                        .LINE     269
                        CBI       024h, 003h
                        .LINE     272
                        LDI       _ACCA, 053h
                        OUT       SPCR, _ACCA
                        .LINE     273
                        LDI       _ACCA, 000h
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0058
                        BREQ      MMCLoader._L0058
                        .BLOCK    273
                        .LINE     274
                        LDI       _ACCBLO, SPSR AND 0FFh
                        LDI       _ACCBHI, SPSR SHRB 8
                        LDI       _ACCA, 000h
                        RCALL     SYSTEM.ExclBit8
                        .ENDBLOCK 275
                        .BRANCH   20,MMCLoader._L0059
                        RJMP      MMCLoader._L0059
MMCLoader._L0058:
                        .BLOCK    275
                        .LINE     276
                        LDI       _ACCBLO, SPSR AND 0FFh
                        LDI       _ACCBHI, SPSR SHRB 8
                        LDI       _ACCA, 000h
                        RCALL     SYSTEM.InclBit8
                        .ENDBLOCK 277
MMCLoader._L0059:
                        .LINE     278
                        LDI       _ACCA, 00001h SHRB 8
                        LDI       _ACCB, 00001h AND 0FFh
                        STD       Y+003h, _ACCA
                        STD       Y+002h, _ACCB
                        .LINE     279
MMCLoader._L0061:
                        LDD       _ACCB, Y+002h
                        LDD       _ACCA, Y+003h
                        CPI       _ACCA, 000h
                        BRNE      MMCLoader._L0063
                        CPI       _ACCB, 00Ah
MMCLoader._L0063:
                        .BRANCH   1, MMCLoader._L0065
                        BRLO      MMCLoader._L0065
                        .BRANCH   4, MMCLoader._L0062
                        BRNE      MMCLoader._L0062
MMCLoader._L0065:
                        .BLOCK    279
                        .LINE     280
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        .LINE     281
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000002h
                        LD        _ACCBLO, Z
                        LDD       _ACCBHI, Z+1
                        ADIW      _ACCBLO, 1
                        ST        Z, _ACCBLO
                        STD       Z+1, _ACCBHI
                        .ENDBLOCK 282
                        .LINE     282
                        .BRANCH   20,MMCLoader._L0061
                        RJMP      MMCLoader._L0061
MMCLoader._L0062:
                        .LINE     284
                        LDI       _ACCA, 000h
                        STD       Y+001h, _ACCA
                        .LINE     285
                        LDI       _ACCB, 00001h AND 0FFh
                        STD       Y+003h, _ACCA
                        STD       Y+002h, _ACCB
                        .LINE     286
MMCLoader._L0066:
                        LDD       _ACCB, Y+002h
                        LDD       _ACCA, Y+003h
                        CPI       _ACCA, 002h
                        BRNE      MMCLoader._L0068
                        CPI       _ACCB, 000h
MMCLoader._L0068:
                        .BRANCH   1, MMCLoader._L0070
                        BRLO      MMCLoader._L0070
                        .BRANCH   4, MMCLoader._L0067
                        BRNE      MMCLoader._L0067
MMCLoader._L0070:
                        .BLOCK    286
                        .LINE     287
                        LDI       _ACCA, 040h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  2
                        ST        -Y, _ACCA
                        .FRAME  3
                        ST        -Y, _ACCA
                        .FRAME  4
                        ST        -Y, _ACCA
                        .FRAME  5
                        LDI       _ACCA, 095h
                        ST        -Y, _ACCA
                        .FRAME  6
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCSENDCMD
                        RCALL     MMCLoader.MMCSENDCMD
                        ADIW      _FRAMEPTR, 9

                        STD       Y+000h, _ACCA
                        .LINE     288
                        SBI       025h, 000h
                        .LINE     289
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        .LINE     290
                        LDD       _ACCA, Y+000h
                        CPI       _ACCA, 001h
                        .BRANCH   4, MMCLoader._L0072
                        BRNE      MMCLoader._L0072
                        .BLOCK    290
                        .LINE     291
                        LDI       _ACCA, 0FFh
                        STD       Y+001h, _ACCA
                        .LINE     292
                        .BRANCH   20,MMCLoader._L0067
                        RJMP      MMCLoader._L0067
                        .ENDBLOCK 293
MMCLoader._L0072:
                        .LINE     294
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000002h
                        LD        _ACCBLO, Z
                        LDD       _ACCBHI, Z+1
                        ADIW      _ACCBLO, 1
                        ST        Z, _ACCBLO
                        STD       Z+1, _ACCBHI
                        .ENDBLOCK 295
                        .LINE     295
                        .BRANCH   20,MMCLoader._L0066
                        RJMP      MMCLoader._L0066
MMCLoader._L0067:
                        .LINE     296
                        LDD       _ACCA, Y+001h
                        COM       _ACCA
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0075
                        BREQ      MMCLoader._L0075
                        .BLOCK    296
                        .LINE     297
                        LDI       _ACCA, 000h
                        .BRANCH   20,MMCLoader.MMCInit_X
                        RJMP      MMCLoader.MMCInit_X
                        .ENDBLOCK 298
MMCLoader._L0075:
                        .LINE     300
                        LDI       _ACCA, 000h
                        STD       Y+001h, _ACCA
                        .LINE     301
                        LDI       _ACCB, 00001h AND 0FFh
                        STD       Y+003h, _ACCA
                        STD       Y+002h, _ACCB
                        .LINE     302
MMCLoader._L0078:
                        LDD       _ACCB, Y+002h
                        LDD       _ACCA, Y+003h
                        CPI       _ACCA, 008h
                        BRNE      MMCLoader._L0080
                        CPI       _ACCB, 000h
MMCLoader._L0080:
                        .BRANCH   1, MMCLoader._L0082
                        BRLO      MMCLoader._L0082
                        .BRANCH   4, MMCLoader._L0079
                        BRNE      MMCLoader._L0079
MMCLoader._L0082:
                        .BLOCK    302
                        .LINE     303
                        LDI       _ACCA, 041h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  2
                        ST        -Y, _ACCA
                        .FRAME  3
                        ST        -Y, _ACCA
                        .FRAME  4
                        ST        -Y, _ACCA
                        .FRAME  5
                        LDI       _ACCA, 0FFh
                        ST        -Y, _ACCA
                        .FRAME  6
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCSENDCMD
                        RCALL     MMCLoader.MMCSENDCMD
                        ADIW      _FRAMEPTR, 9

                        STD       Y+000h, _ACCA
                        .LINE     304
                        SBI       025h, 000h
                        .LINE     305
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        .LINE     306
                        LDD       _ACCA, Y+000h
                        CPI       _ACCA, 000h
                        .BRANCH   4, MMCLoader._L0084
                        BRNE      MMCLoader._L0084
                        .BLOCK    306
                        .LINE     307
                        LDI       _ACCA, 0FFh
                        STD       Y+001h, _ACCA
                        .LINE     308
                        .BRANCH   20,MMCLoader._L0079
                        RJMP      MMCLoader._L0079
                        .ENDBLOCK 309
MMCLoader._L0084:
                        .LINE     310
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000002h
                        LD        _ACCBLO, Z
                        LDD       _ACCBHI, Z+1
                        ADIW      _ACCBLO, 1
                        ST        Z, _ACCBLO
                        STD       Z+1, _ACCBHI
                        .ENDBLOCK 311
                        .LINE     311
                        .BRANCH   20,MMCLoader._L0078
                        RJMP      MMCLoader._L0078
MMCLoader._L0079:
                        .LINE     312
                        LDD       _ACCA, Y+001h
                        .BRANCH   20,MMCLoader.MMCInit_X
                        .FRAME  1
                        .FRAME  2
                        .FRAME  3
                        .FRAME  4
                        .FRAME  5
                        .FRAME  6
                        .FRAME  0



                        .ENDBLOCK 320
MMCLoader.MMCInit_X:
                        .LINE     320
                        .BRANCH   19
                        RET
                        .ENDFUNC  320

                        .FUNC     MMCWaitStart, 00143h, 00020h
MMCLoader.MMCWaitStart:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 2
                        .BLOCK    326
                        .LINE     327
                        LDI       _ACCA, 00000h SHRB 8
                        LDI       _ACCB, 00000h AND 0FFh
                        STD       Y+001h, _ACCA
                        STD       Y+000h, _ACCB
                        .LINE     328
MMCLoader._L0088:
                        LDD       _ACCB, Y+000h
                        LDD       _ACCA, Y+001h
                        LDI       _ACCBLO, 080h
                        EOR       _ACCA, _ACCBLO
                        CPI       _ACCA, 090h
                        BRNE      MMCLoader._L0090
                        CPI       _ACCB, 000h
MMCLoader._L0090:
                        .BRANCH   1, MMCLoader._L0092
                        BRLO      MMCLoader._L0092
                        .BRANCH   4, MMCLoader._L0089
                        BRNE      MMCLoader._L0089
MMCLoader._L0092:
                        .BLOCK    328
                        .LINE     329
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        CPI       _ACCA, 0FEh
                        .BRANCH   4, MMCLoader._L0094
                        BRNE      MMCLoader._L0094
                        .BLOCK    329
                        .LINE     330
                        LDI       _ACCA, 0FFh
                        .BRANCH   20,MMCLoader.MMCWaitStart_X
                        RJMP      MMCLoader.MMCWaitStart_X
                        .ENDBLOCK 331
MMCLoader._L0094:
                        .LINE     332
                        MOVW      _ACCCLO, _FRAMEPTR
                        LD        _ACCBLO, Z
                        LDD       _ACCBHI, Z+1
                        ADIW      _ACCBLO, 1
                        ST        Z, _ACCBLO
                        STD       Z+1, _ACCBHI
                        .ENDBLOCK 333
                        .LINE     333
                        .BRANCH   20,MMCLoader._L0088
                        RJMP      MMCLoader._L0088
MMCLoader._L0089:
                        .LINE     334
                        LDI       _ACCA, 000h
                        .ENDBLOCK 335
MMCLoader.MMCWaitStart_X:
                        .LINE     335
                        .BRANCH   19
                        RET
                        .ENDFUNC  335

                        .FUNC     MMCReadSector, 00155h, 00020h
MMCLoader.MMCReadSector:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 3
                        .BLOCK    345
                        .LINE     346
                        LDD       _ACCCHI, Y+006h
                        LDD       _ACCCLO, Y+005h
                        LDD       _ACCBHI, Y+004h
                        LDD       _ACCBLO, Y+003h
                        LDS       _ACCB, MMCLoader.PTI_StartSector
                        LDS       _ACCA, MMCLoader.PTI_StartSector+1
                        LDS       _ACCALO, MMCLoader.PTI_StartSector+2
                        LDS       _ACCAHI, MMCLoader.PTI_StartSector+3
                        ADD       _ACCB, _ACCBLO
                        ADC       _ACCA, _ACCBHI
                        ADC       _ACCALO, _ACCCLO
                        ADC       _ACCAHI, _ACCCHI
                        LDI       _ACCDLO, 000000200h AND 0FFh
                        LDI       _ACCDHI, 000000200h SHRB 8
                        LDI       _ACCELO, 000000200h SHRB 16
                        LDI       _ACCEHI, 000000200h SHRB 24
                        CLT
                        BLD       Flags, _SIGN
                        RCALL     SYSTEM.MUL32_R
                        STD       Y+006h, _ACCAHI
                        STD       Y+005h, _ACCALO
                        STD       Y+004h, _ACCA
                        STD       Y+003h, _ACCB
                        .LINE     348
                        LDI       _ACCA, 050h
                        OUT       SPCR, _ACCA
                        .LINE     349
                        LDI       _ACCA, 000h
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0097
                        BREQ      MMCLoader._L0097
                        .BLOCK    349
                        .LINE     350
                        LDI       _ACCBLO, SPSR AND 0FFh
                        LDI       _ACCBHI, SPSR SHRB 8
                        LDI       _ACCA, 000h
                        RCALL     SYSTEM.ExclBit8
                        .ENDBLOCK 351
                        .BRANCH   20,MMCLoader._L0098
                        RJMP      MMCLoader._L0098
MMCLoader._L0097:
                        .BLOCK    351
                        .LINE     352
                        LDI       _ACCBLO, SPSR AND 0FFh
                        LDI       _ACCBHI, SPSR SHRB 8
                        LDI       _ACCA, 000h
                        RCALL     SYSTEM.InclBit8
                        .ENDBLOCK 353
MMCLoader._L0098:
                        .LINE     355
                        LDI       _ACCA, 051h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDD       _ACCA, Y+007h
                        ST        -Y, _ACCA
                        .FRAME  2
                        LDD       _ACCA, Y+007h
                        ST        -Y, _ACCA
                        .FRAME  3
                        LDD       _ACCA, Y+007h
                        ST        -Y, _ACCA
                        .FRAME  4
                        LDD       _ACCA, Y+007h
                        ST        -Y, _ACCA
                        .FRAME  5
                        LDI       _ACCA, 0FFh
                        ST        -Y, _ACCA
                        .FRAME  6
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCSENDCMD
                        RCALL     MMCLoader.MMCSENDCMD
                        ADIW      _FRAMEPTR, 9

                        STD       Y+000h, _ACCA
                        .LINE     359
                        CPI       _ACCA, 000h
                        BRNE      _CSE0001
                        .BLOCK    359
                        .LINE     360
                        .ENDBLOCK 362
MMCLoader._L0101:
                        .LINE     363
                        .BRANCH   17,MMCLoader.MMCWAITSTART
                        RCALL     MMCLoader.MMCWAITSTART
                        ADIW      _FRAMEPTR, 2

                        COM       _ACCA
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0104
                        BREQ      MMCLoader._L0104
                        .BLOCK    363
                        .LINE     364
_CSE0001:                         
                        SBI       025h, 000h
                        .LINE     361
                        .LINE     365
                        LDI       _ACCA, 000h
                        .BRANCH   20,MMCLoader.MMCReadSector_X
                        RJMP      MMCLoader.MMCReadSector_X
                        .ENDBLOCK 366
MMCLoader._L0104:
                        .LINE     368
                        LDI       _ACCA, 00000h SHRB 8
                        LDI       _ACCB, 00000h AND 0FFh
                        STD       Y+002h, _ACCA
                        STD       Y+001h, _ACCB
                        .LINE     369
MMCLoader._L0107:
                        LDD       _ACCB, Y+001h
                        LDD       _ACCA, Y+002h
                        CPI       _ACCA, 001h
                        BRNE      MMCLoader._L0109
                        CPI       _ACCB, 0FFh
MMCLoader._L0109:
                        .BRANCH   1, MMCLoader._L0111
                        BRLO      MMCLoader._L0111
                        .BRANCH   4, MMCLoader._L0108
                        BRNE      MMCLoader._L0108
MMCLoader._L0111:
                        .BLOCK    369
                        .LINE     370
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        LDD       _ACCB, Y+001h
                        LDD       _ACCA, Y+002h
                        ADD       _ACCCLO, _ACCB
                        ADC       _ACCCHI, _ACCA
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        ST        Z+, _ACCA
                        .LINE     371
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000001h
                        LD        _ACCBLO, Z
                        LDD       _ACCBHI, Z+1
                        ADIW      _ACCBLO, 1
                        ST        Z, _ACCBLO
                        STD       Z+1, _ACCBHI
                        .ENDBLOCK 372
                        .LINE     372
                        .BRANCH   20,MMCLoader._L0107
                        RJMP      MMCLoader._L0107
MMCLoader._L0108:
                        .LINE     373
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        .LINE     374
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        .LINE     375
                        SBI       025h, 000h
                        .LINE     376
                        .BRANCH   17,MMCLoader.SPIGET
                        RCALL     MMCLoader.SPIGET

                        .LINE     377
                        LDI       _ACCA, 0FFh
                        .ENDBLOCK 378
MMCLoader.MMCReadSector_X:
                        .LINE     378
                        .BRANCH   19
                        RET
                        .ENDFUNC  378

                        .FUNC     FATInit, 00182h, 00020h
MMCLoader.FATInit:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 2
                        .BLOCK    389
                        .LINE     390
                        .BRANCH   17,MMCLoader.MMCINIT
                        RCALL     MMCLoader.MMCINIT
                        ADIW      _FRAMEPTR, 4

                        COM       _ACCA
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0112
                        BREQ      MMCLoader._L0112
                        .BLOCK    390
                        .LINE     391
                        .BRANCH   20, _CSE0002
                        RJMP      _CSE0002
                        .ENDBLOCK 392
MMCLoader._L0112:
                        .LINE     393
                        LDI       _ACCB, 000000000h AND 0FFh
                        LDI       _ACCA, 000000000h SHRB 8
                        LDI       _ACCALO, 000000000h SHRB 16
                        LDI       _ACCAHI, 000000000h SHRB 24
                        STS       MMCLOADER.PTI_STARTSECTOR, _ACCB
                        STS       MMCLOADER.PTI_STARTSECTOR+1, _ACCA
                        STS       MMCLOADER.PTI_STARTSECTOR+2, _ACCALO
                        STS       MMCLOADER.PTI_STARTSECTOR+3, _ACCAHI
                        .LINE     394
                        ST        -Y, _ACCAHI
                        ST        -Y, _ACCALO
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  4
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCREADSECTOR
                        RCALL     MMCLoader.MMCREADSECTOR
                        ADIW      _FRAMEPTR, 7

                        COM       _ACCA
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0115
                        BREQ      MMCLoader._L0115
                        .BLOCK    394
                        .LINE     395
                        .BRANCH   20, _CSE0002
                        RJMP      _CSE0002
                        .ENDBLOCK 396
MMCLoader._L0115:
                        .LINE     398
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        SUBI      _ACCCLO, -001C6h AND 0FFh
                        SBCI      _ACCCHI, -001C6h SHRB 8
                        LD        _ACCA, Z+
                        MOVW      _ACCCLO, _FRAMEPTR
                        ST        Z+, _ACCA
                        .LINE     399
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 1
                        PUSH      _ACCCLO
                        PUSH      _ACCCHI
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        SUBI      _ACCCLO, -001C7h AND 0FFh
                        SBCI      _ACCCHI, -001C7h SHRB 8
                        LD        _ACCA, Z+
                        POP       _ACCCHI
                        POP       _ACCCLO
                        ST        Z+, _ACCA
                        .LINE     400
                        LDI       _ACCCLO, 00516h AND 0FFh
                        LDI       _ACCCHI, 00516h SHRB 8
                        LDD       _ACCB, Y+000h
                        LDD       _ACCA, Y+001h
                        ST        Z+, _ACCB
                        ST        Z+, _ACCA
                        .LINE     401
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        SUBI      _ACCCLO, -001C8h AND 0FFh
                        SBCI      _ACCCHI, -001C8h SHRB 8
                        LD        _ACCA, Z+
                        MOVW      _ACCCLO, _FRAMEPTR
                        ST        Z+, _ACCA
                        .LINE     402
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 1
                        PUSH      _ACCCLO
                        PUSH      _ACCCHI
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        SUBI      _ACCCLO, -001C9h AND 0FFh
                        SBCI      _ACCCHI, -001C9h SHRB 8
                        LD        _ACCA, Z+
                        POP       _ACCCHI
                        POP       _ACCCLO
                        ST        Z+, _ACCA
                        .LINE     403
                        LDI       _ACCCLO, 00518h AND 0FFh
                        LDI       _ACCCHI, 00518h SHRB 8
                        LDD       _ACCB, Y+000h
                        LDD       _ACCA, Y+001h
                        ST        Z+, _ACCB
                        ST        Z+, _ACCA
                        .LINE     405
                        LDI       _ACCB, 000000000h AND 0FFh
                        LDI       _ACCA, 000000000h SHRB 8
                        LDI       _ACCALO, 000000000h SHRB 16
                        LDI       _ACCAHI, 000000000h SHRB 24
                        ST        -Y, _ACCAHI
                        ST        -Y, _ACCALO
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  4
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCREADSECTOR
                        RCALL     MMCLoader.MMCREADSECTOR
                        ADIW      _FRAMEPTR, 7

                        COM       _ACCA
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0118
                        BREQ      MMCLoader._L0118
                        .BLOCK    405
                        .LINE     406
_CSE0002:                         
                        LDI       _ACCA, 000h
                        .BRANCH   20,MMCLoader.FATInit_X
                        RJMP      MMCLoader.FATInit_X
                        .ENDBLOCK 407
MMCLoader._L0118:
                        .LINE     408
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        ADIW      _ACCCLO, 0000Dh
                        LD        _ACCA, Z+
                        STS       MMCLOADER.BPB_SECPERCLUSTER, _ACCA
                        .LINE     409
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        ADIW      _ACCCLO, 0000Eh
                        LD        _ACCA, Z+
                        LDI       _ACCCHI, 0051Bh SHRB 8
                        LDI       _ACCCLO, 0051Bh AND 0FFh
                        ST        Z+, _ACCA
                        .LINE     410
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        ADIW      _ACCCLO, 0000Fh
                        LD        _ACCA, Z+
                        LDI       _ACCCHI, 0051Ch SHRB 8
                        LDI       _ACCCLO, 0051Ch AND 0FFh
                        ST        Z+, _ACCA
                        .LINE     411
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        ADIW      _ACCCLO, 00010h
                        LD        _ACCA, Z+
                        STS       MMCLOADER.BPB_NUMFATS, _ACCA
                        .LINE     412
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        ADIW      _ACCCLO, 00016h
                        LD        _ACCA, Z+
                        LDI       _ACCCHI, 0051Eh SHRB 8
                        LDI       _ACCCLO, 0051Eh AND 0FFh
                        ST        Z+, _ACCA
                        .LINE     413
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        ADIW      _ACCCLO, 00017h
                        LD        _ACCA, Z+
                        LDI       _ACCCHI, 0051Fh SHRB 8
                        LDI       _ACCCLO, 0051Fh AND 0FFh
                        ST        Z+, _ACCA
                        .LINE     415
                        LDS       _ACCB, MMCLoader.BPB_RsvdSecCnt
                        LDS       _ACCA, MMCLoader.BPB_RsvdSecCnt+1
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        PUSH      _ACCB
                        PUSH      _ACCA
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
                        LDS       _ACCB, MMCLoader.BPB_FatSz
                        LDS       _ACCA, MMCLoader.BPB_FatSz+1
                        PUSH      _ACCB
                        PUSH      _ACCA
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
                        LDS       _ACCB, MMCLoader.BPB_NumFATs
                        CLR       _ACCA
                        CLT
                        BLD       Flags, _SIGN
                        RCALL     SYSTEM.MUL32
                        POP       _ACCCHI
                        POP       _ACCCLO
                        POP       _ACCBHI
                        POP       _ACCBLO
                        ADD       _ACCB, _ACCBLO
                        ADC       _ACCA, _ACCBHI
                        ADC       _ACCALO, _ACCCLO
                        ADC       _ACCAHI, _ACCCHI
                        STS       MMCLOADER.FAT_ROOTDIR, _ACCB
                        STS       MMCLOADER.FAT_ROOTDIR+1, _ACCA
                        STS       MMCLOADER.FAT_ROOTDIR+2, _ACCALO
                        STS       MMCLOADER.FAT_ROOTDIR+3, _ACCAHI
                        .LINE     416
                        LDS       _ACCB, MMCLoader.BPB_RsvdSecCnt
                        LDS       _ACCA, MMCLoader.BPB_RsvdSecCnt+1
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        PUSH      _ACCB
                        PUSH      _ACCA
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
                        LDS       _ACCB, MMCLoader.BPB_NumFATs
                        CLR       _ACCA
                        PUSH      _ACCB
                        PUSH      _ACCA
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
                        LDS       _ACCB, MMCLoader.BPB_FatSz
                        LDS       _ACCA, MMCLoader.BPB_FatSz+1
                        CLT
                        BLD       Flags, _SIGN
                        RCALL     SYSTEM.MUL32
                        POP       _ACCCHI
                        POP       _ACCCLO
                        POP       _ACCBHI
                        POP       _ACCBLO
                        ADD       _ACCB, _ACCBLO
                        ADC       _ACCA, _ACCBHI
                        ADC       _ACCALO, _ACCCLO
                        ADC       _ACCAHI, _ACCCHI
                        SUBI      _ACCB, -000000020h AND 0FFh
                        SBCI      _ACCA, -000000020h SHRB 8
                        SBCI      _ACCALO, -000000020h SHRB 16
                        SBCI      _ACCAHI, -000000020h SHRB 24
                        STS       MMCLOADER.FAT_STARTDATA, _ACCB
                        STS       MMCLOADER.FAT_STARTDATA+1, _ACCA
                        STS       MMCLOADER.FAT_STARTDATA+2, _ACCALO
                        STS       MMCLOADER.FAT_STARTDATA+3, _ACCAHI
                        .LINE     417
                        LDI       _ACCA, 0FFh
                        .ENDBLOCK 418
MMCLoader.FATInit_X:
                        .LINE     418
                        .BRANCH   19
                        RET
                        .ENDFUNC  418

                        .FUNC     FindFirstCluster, 001ABh, 00020h
MMCLoader.FindFirstCluster:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 4
                        .BLOCK    432
                        .LINE     433
                        LDI       _ACCA, 000h
                        STD       Y+003h, _ACCA
                        .LINE     434
MMCLoader._L0121:
                        LDD       _ACCA, Y+003h
                        CPI       _ACCA, 01Fh
                        .BRANCH   1, MMCLoader._L0124
                        BRLO      MMCLoader._L0124
                        .BRANCH   3, MMCLoader._L0124
                        BREQ      MMCLoader._L0124
                        .BRANCH   20,MMCLoader._L0122
                        RJMP      MMCLoader._L0122
MMCLoader._L0124:
                        .BLOCK    434
                        .LINE     435
                        LDS       _ACCBLO, MMCLoader.FAT_RootDir
                        LDS       _ACCBHI, MMCLoader.FAT_RootDir+1
                        LDS       _ACCCLO, MMCLoader.FAT_RootDir+2
                        LDS       _ACCCHI, MMCLoader.FAT_RootDir+3
                        LDD       _ACCB, Y+003h
                        CLR       _ACCA
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        ADD       _ACCB, _ACCBLO
                        ADC       _ACCA, _ACCBHI
                        ADC       _ACCALO, _ACCCLO
                        ADC       _ACCAHI, _ACCCHI
                        ST        -Y, _ACCAHI
                        ST        -Y, _ACCALO
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  4
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCREADSECTOR
                        RCALL     MMCLoader.MMCREADSECTOR
                        ADIW      _FRAMEPTR, 7

                        .LINE     436
                        LDI       _ACCB, MMCLoader.Dir AND 0FFh
                        LDI       _ACCA, MMCLoader.Dir SHRB 8
                        MOVW      _ACCCLO, _FRAMEPTR
                        ST        Z+, _ACCB
                        ST        Z+, _ACCA
                        .LINE     437
                        LDI       _ACCA, 001h
                        STD       Y+002h, _ACCA
                        .LINE     438
MMCLoader._L0125:
                        LDD       _ACCA, Y+002h
                        CPI       _ACCA, 010h
                        .BRANCH   1, MMCLoader._L0128
                        BRLO      MMCLoader._L0128
                        .BRANCH   3, MMCLoader._L0128
                        BREQ      MMCLoader._L0128
                        .BRANCH   20,MMCLoader._L0126
                        RJMP      MMCLoader._L0126
MMCLoader._L0128:
                        .BLOCK    438
                        .LINE     439
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ST        -Y, _ACCCHI
                        ST        -Y, _ACCCLO
                        .FRAME  2
                        .LINE     440
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        LD        _ACCB, Z+
                        LDI       _ACCCLO, MMCLoader.UPDNAME AND 0FFh
                        LDI       _ACCCHI, MMCLoader.UPDNAME SHRB 8
                        ADIW      _ACCCLO, 00001h
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM      _ACCA, Z
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0129
                        SER       _ACCA
MMCLoader._L0129:
                        PUSH      _ACCA
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 00001h
                        LD        _ACCB, Z+
                        LDI       _ACCCLO, MMCLoader.UPDNAME AND 0FFh
                        LDI       _ACCCHI, MMCLoader.UPDNAME SHRB 8
                        ADIW      _ACCCLO, 00002h
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM      _ACCA, Z
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0130
                        SER       _ACCA
MMCLoader._L0130:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        PUSH      _ACCA
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 00002h
                        LD        _ACCB, Z+
                        LDI       _ACCCLO, MMCLoader.UPDNAME AND 0FFh
                        LDI       _ACCCHI, MMCLoader.UPDNAME SHRB 8
                        ADIW      _ACCCLO, 00003h
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM      _ACCA, Z
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0131
                        SER       _ACCA
MMCLoader._L0131:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        PUSH      _ACCA
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 00003h
                        LD        _ACCB, Z+
                        LDI       _ACCCLO, MMCLoader.UPDNAME AND 0FFh
                        LDI       _ACCCHI, MMCLoader.UPDNAME SHRB 8
                        ADIW      _ACCCLO, 00004h
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM      _ACCA, Z
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0132
                        SER       _ACCA
MMCLoader._L0132:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        PUSH      _ACCA
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 00004h
                        LD        _ACCB, Z+
                        LDI       _ACCCLO, MMCLoader.UPDNAME AND 0FFh
                        LDI       _ACCCHI, MMCLoader.UPDNAME SHRB 8
                        ADIW      _ACCCLO, 00005h
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM      _ACCA, Z
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0133
                        SER       _ACCA
MMCLoader._L0133:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        PUSH      _ACCA
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 00005h
                        LD        _ACCB, Z+
                        LDI       _ACCCLO, MMCLoader.UPDNAME AND 0FFh
                        LDI       _ACCCHI, MMCLoader.UPDNAME SHRB 8
                        ADIW      _ACCCLO, 00006h
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM      _ACCA, Z
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0134
                        SER       _ACCA
MMCLoader._L0134:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        PUSH      _ACCA
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 00006h
                        LD        _ACCB, Z+
                        LDI       _ACCCLO, MMCLoader.UPDNAME AND 0FFh
                        LDI       _ACCCHI, MMCLoader.UPDNAME SHRB 8
                        ADIW      _ACCCLO, 00007h
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM      _ACCA, Z
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0135
                        SER       _ACCA
MMCLoader._L0135:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        PUSH      _ACCA
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 00007h
                        LD        _ACCB, Z+
                        LDI       _ACCCLO, MMCLoader.UPDNAME AND 0FFh
                        LDI       _ACCCHI, MMCLoader.UPDNAME SHRB 8
                        ADIW      _ACCCLO, 00008h
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM      _ACCA, Z
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0h
                        BRNE      MMCLoader._L0136
                        SER       _ACCA
MMCLoader._L0136:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0137
                        BREQ      MMCLoader._L0137
                        .BLOCK    443
                        .LINE     444
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 0001Ah
                        LD        _ACCB, Z+
                        LD        _ACCA, Z+
                        STS       MMCLOADER.FIRSTCLUSTER, _ACCB
                        STS       MMCLOADER.FIRSTCLUSTER+1, _ACCA
                        .LINE     445
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 0001Ah
                        LD        _ACCB, Z+
                        LD        _ACCA, Z+
                        STS       MMCLOADER.NEXTCLUSTER, _ACCB
                        STS       MMCLOADER.NEXTCLUSTER+1, _ACCA
                        .LINE     446
                        LDI       _ACCA, 0FFh
                        ADIW      _FRAMEPTR, 2
                        .BRANCH   20,MMCLoader.FindFirstCluster_X
                        RJMP      MMCLoader.FindFirstCluster_X
                        .ENDBLOCK 447
MMCLoader._L0137:
                        .LINE     448
                        ADIW      _FRAMEPTR, 2
                        .FRAME  0
                        .LINE     449
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        ADIW      _ACCCLO, 32
                        STD       Y+001h, _ACCCHI
                        STD       Y+000h, _ACCCLO
                        .LINE     450
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000002h
                        LD        _ACCA, Z
                        INC       _ACCA
                        ST        Z, _ACCA
                        .ENDBLOCK 451
                        .LINE     451
                        .BRANCH   20,MMCLoader._L0125
                        RJMP      MMCLoader._L0125
MMCLoader._L0126:
                        .LINE     452
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000003h
                        LD        _ACCA, Z
                        INC       _ACCA
                        ST        Z, _ACCA
                        .ENDBLOCK 453
                        .LINE     453
                        .BRANCH   20,MMCLoader._L0121
                        RJMP      MMCLoader._L0121
MMCLoader._L0122:
                        .LINE     454
                        LDI       _ACCA, 000h
                        .ENDBLOCK 455
MMCLoader.FindFirstCluster_X:
                        .LINE     455
                        .BRANCH   19
                        RET
                        .ENDFUNC  455

                        .FUNC     FindNextCluster, 001CDh, 00020h
MMCLoader.FindNextCluster:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 10
                        .BLOCK    466
                        .LINE     467
                        LDS       _ACCB, MMCLoader.NextCluster
                        LDS       _ACCA, MMCLoader.NextCluster+1
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        STD       Y+007h, _ACCAHI
                        STD       Y+006h, _ACCALO
                        STD       Y+005h, _ACCA
                        STD       Y+004h, _ACCB
                        .LINE     468
                        ADD       _ACCB, _ACCB
                        ADC       _ACCA, _ACCA
                        ADC       _ACCALO, _ACCALO
                        ADC       _ACCAHI, _ACCAHI
                        STD       Y+007h, _ACCAHI
                        STD       Y+006h, _ACCALO
                        STD       Y+005h, _ACCA
                        STD       Y+004h, _ACCB
                        .LINE     469
                        MOVW      _ACCDLO, _ACCB
                        MOVW      _ACCELO, _ACCALO
                        LDI       _ACCBLO, 000000200h AND 0FFh
                        LDI       _ACCBHI, 000000200h SHRB 8
                        LDI       _ACCCLO, 000000200h SHRB 16
                        LDI       _ACCCHI, 000000200h SHRB 24
                        CLT
                        BLD       Flags, _SIGN
                        RCALL     SYSTEM.DIV32_R
                        MOVW      _ACCBLO, _ACCB
                        MOVW      _ACCCLO, _ACCALO
                        LDS       _ACCB, MMCLoader.BPB_RsvdSecCnt
                        LDS       _ACCA, MMCLoader.BPB_RsvdSecCnt+1
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        ADD       _ACCB, _ACCBLO
                        ADC       _ACCA, _ACCBHI
                        ADC       _ACCALO, _ACCCLO
                        ADC       _ACCAHI, _ACCCHI
                        STD       Y+003h, _ACCAHI
                        STD       Y+002h, _ACCALO
                        STD       Y+001h, _ACCA
                        STD       Y+000h, _ACCB
                        .LINE     470
                        ST        -Y, _ACCAHI
                        ST        -Y, _ACCALO
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  4
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCREADSECTOR
                        RCALL     MMCLoader.MMCREADSECTOR
                        ADIW      _FRAMEPTR, 7

                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0140
                        BREQ      MMCLoader._L0140
                        .BLOCK    470
                        .LINE     471
                        LDD       _ACCAHI, Y+007h
                        LDD       _ACCALO, Y+006h
                        LDD       _ACCA, Y+005h
                        LDD       _ACCB, Y+004h
                        ANDI      _ACCB, 0FFh
                        ANDI      _ACCA, 001h
                        ANDI      _ACCALO, 000h
                        ANDI      _ACCAHI, 000h
                        STD       Y+007h, _ACCAHI
                        STD       Y+006h, _ACCALO
                        STD       Y+005h, _ACCA
                        STD       Y+004h, _ACCB
                        .LINE     472
                        STD       Y+009h, _ACCA
                        STD       Y+008h, _ACCB
                        .LINE     473
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        ADD       _ACCCLO, _ACCB
                        ADC       _ACCCHI, _ACCA
                        LD        _ACCA, Z+
                        LDI       _ACCCHI, 0052Eh SHRB 8
                        LDI       _ACCCLO, 0052Eh AND 0FFh
                        ST        Z+, _ACCA
                        .LINE     474
                        LDI       _ACCCLO, MMCLoader.buffer AND 0FFh
                        LDI       _ACCCHI, MMCLoader.buffer SHRB 8
                        LDD       _ACCB, Y+008h
                        LDD       _ACCA, Y+009h
                        SUBI      _ACCB, -00001h AND 0FFh
                        SBCI      _ACCA, -00001h SHRB 8
                        ADD       _ACCCLO, _ACCB
                        ADC       _ACCCHI, _ACCA
                        LD        _ACCA, Z+
                        LDI       _ACCCHI, 0052Fh SHRB 8
                        LDI       _ACCCLO, 0052Fh AND 0FFh
                        ST        Z+, _ACCA
                        .LINE     475
                        LDS       _ACCB, MMCLoader.NextCluster
                        LDS       _ACCA, MMCLoader.NextCluster+1
                        CPI       _ACCA, 0FFh
                        BRNE      MMCLoader._L0143
                        CPI       _ACCB, 0F8h
MMCLoader._L0143:
                        BRSH      MMCLoader._L0140
                        .BLOCK    476
                        .LINE     476
                        .ENDBLOCK 477
MMCLoader._L0145:
                        .BLOCK    477
                        .LINE     478
                        LDI       _ACCA, 0FFh
                        .BRANCH   20,MMCLoader.FindNextCluster_X
                        RJMP      MMCLoader.FindNextCluster_X
                        .ENDBLOCK 479
                        .ENDBLOCK 480
MMCLoader._L0140:
                        .LINE     481
                        LDI       _ACCA, 000h
                        .ENDBLOCK 482
MMCLoader.FindNextCluster_X:
                        .LINE     482
                        .BRANCH   19
                        RET
                        .ENDFUNC  482

                        .FUNC     WritePage, 001E8h, 00020h
MMCLoader.WritePage:
                        .RETURNS   0
                        SBIW      _FRAMEPTR, 1
                        .BLOCK    491
                        .LINE     492
                        LDS       _ACCB, MMCLoader.FlashAdr
                        LDS       _ACCA, MMCLoader.FlashAdr+1
                        STS       FLASH_ADDR, _ACCB
                        STS       FLASH_ADDR+1, _ACCA
                        .LINE     493
                        LDS       _ACCA, MMCLoader.FlashPage
                        STS       FLASH_PAGE, _ACCA
                        .LINE     494
                        RCALL     SYSTEM.FLASHERASEPAGE

                        .LINE     495
                        LDS       _ACCB, MMCLoader.FlashAdr
                        LDS       _ACCA, MMCLoader.FlashAdr+1
                        STS       FLASH_ADDR, _ACCB
                        STS       FLASH_ADDR+1, _ACCA
                        .LINE     497
                        .LOOP
                        .LOOP_B
                        .FRAME    0
                        LDD       _ACCA, Y+001h
                        STD       Y+000h, _ACCA
                        SUBI      _ACCA, -07Fh AND 0FFh
                        ST        -Y, _ACCA
                        .FRAME    1
                        LDD       _ACCA, Y+001h
MMCLoader._L0150:
                        LDD       _ACCB, Y+000h
                        CP        _ACCB, _ACCA
                        .BRANCH   1, MMCLoader._L0149
                        BRLO      MMCLoader._L0149
                        .BLOCK    498
                        .LINE     498
                        LDI       _ACCCLO, MMCLoader.flash AND 0FFh
                        LDI       _ACCCHI, MMCLoader.flash SHRB 8
                        LDD       _ACCB, Y+001h
                        CLR       _ACCA
                        LSL       _ACCB
                        ROL       _ACCA
                        ADD       _ACCCLO, _ACCB
                        ADC       _ACCCHI, _ACCA
                        LD        _ACCB, Z+
                        LD        _ACCA, Z+
                        .FRAME    1
                        RCALL     SYSTEM.FLASHWRITEPAGE

                        .LINE     499
                        LDS       _ACCBLO, MMCLoader.WordsWritten
                        LDS       _ACCBHI, MMCLoader.WordsWritten+1
                        LDS       _ACCCLO, MMCLoader.WordsWritten+2
                        LDS       _ACCCHI, MMCLoader.WordsWritten+3
                        ADIW      _ACCBLO, 1
                        BRCC      MMCLoader._L0153
                        ADIW      _ACCCLO, 1
MMCLoader._L0153:
                        STS       MMCLoader.WordsWritten, _ACCBLO
                        STS       MMCLoader.WordsWritten+1, _ACCBHI
                        STS       MMCLoader.WordsWritten+2, _ACCCLO
                        STS       MMCLoader.WordsWritten+3, _ACCCHI
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        .ENDBLOCK 500
                        .LINE     500
                        LDD       _ACCA, Y+001h
                        INC       _ACCA
                        STD       Y+001h, _ACCA
                        TST       _ACCA
                        .BRANCH   4, MMCLoader._L0150
                        BRNE      MMCLoader._L0150
MMCLoader._L0149:
                        ADIW      _FRAMEPTR, 1
                        .FRAME  0
                        .ENDLOOP
                        .LINE     501
                        LDS       _ACCB, MMCLoader.FlashAdr
                        LDS       _ACCA, MMCLoader.FlashAdr+1
                        STS       FLASH_ADDR, _ACCB
                        STS       FLASH_ADDR+1, _ACCA
                        .LINE     502
                        RCALL     SYSTEM.FLASHPROGPAGE

                        .LINE     503
                        LDS       _ACCBLO, MMCLoader.FlashAdr
                        LDS       _ACCBHI, MMCLoader.FlashAdr+1
                        SUBI      _ACCBLO, 0FF00h AND 0FFh
                        SBCI      _ACCBHI, 0FF00h SHRB 8
                        STS       MMCLoader.FlashAdr, _ACCBLO
                        STS       MMCLoader.FlashAdr+1, _ACCBHI
                        .LINE     504
                        LDS       _ACCB, MMCLoader.FlashAdr
                        LDS       _ACCA, MMCLoader.FlashAdr+1
                        CPI       _ACCA, 000h
                        BRNE      MMCLoader._L0154
                        CPI       _ACCB, 000h
MMCLoader._L0154:
                        .BRANCH   4, MMCLoader._L0156
                        BRNE      MMCLoader._L0156
                        .BLOCK    504
                        .LINE     505
                        LDS       _ACCA, MMCLoader.FlashPage
                        INC       _ACCA
                        STS       MMCLoader.FlashPage, _ACCA
                        .ENDBLOCK 506
MMCLoader._L0156:
                        .ENDBLOCK 507
                        .LINE     507
                        .BRANCH   19
                        RET
                        .ENDFUNC  507

                        .FUNC     GetCluster, 00201h, 00020h
MMCLoader.GetCluster:
                        .RETURNS   1
                        SBIW      _FRAMEPTR, 5
                        .BLOCK    517
                        .LINE     518
                        LDS       _ACCB, MMCLoader.BPB_SecPerCluster
                        CLR       _ACCA
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        PUSH      _ACCB
                        PUSH      _ACCA
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
                        LDS       _ACCB, MMCLoader.NextCluster
                        LDS       _ACCA, MMCLoader.NextCluster+1
                        SUBI      _ACCB, 00002h AND 0FFh
                        SBCI      _ACCA, 00002h SHRB 8
                        CLT
                        BLD       Flags, _SIGN
                        RCALL     SYSTEM.MUL32
                        MOVW      _ACCBLO, _ACCB
                        MOVW      _ACCCLO, _ACCALO
                        LDS       _ACCB, MMCLoader.FAT_StartData
                        LDS       _ACCA, MMCLoader.FAT_StartData+1
                        LDS       _ACCALO, MMCLoader.FAT_StartData+2
                        LDS       _ACCAHI, MMCLoader.FAT_StartData+3
                        ADD       _ACCB, _ACCBLO
                        ADC       _ACCA, _ACCBHI
                        ADC       _ACCALO, _ACCCLO
                        ADC       _ACCAHI, _ACCCHI
                        STD       Y+003h, _ACCAHI
                        STD       Y+002h, _ACCALO
                        STD       Y+001h, _ACCA
                        STD       Y+000h, _ACCB
                        .LINE     519
                        LDI       _ACCA, 001h
                        STD       Y+004h, _ACCA
                        .LINE     520
MMCLoader._L0159:
                        LDD       _ACCB, Y+004h
                        LDS       _ACCA, MMCLoader.BPB_SecPerCluster
                        CP        _ACCB, _ACCA
                        .BRANCH   1, MMCLoader._L0162
                        BRLO      MMCLoader._L0162
                        .BRANCH   3, MMCLoader._L0162
                        BREQ      MMCLoader._L0162
                        .BRANCH   20,MMCLoader._L0160
                        RJMP      MMCLoader._L0160
MMCLoader._L0162:
                        .BLOCK    520
                        .LINE     521
                        LDD       _ACCAHI, Y+003h
                        LDD       _ACCALO, Y+002h
                        LDD       _ACCA, Y+001h
                        LDD       _ACCB, Y+000h
                        ST        -Y, _ACCAHI
                        ST        -Y, _ACCALO
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  4
                        .FRAME  0
                        .BRANCH   17,MMCLoader.MMCREADSECTOR
                        RCALL     MMCLoader.MMCREADSECTOR
                        ADIW      _FRAMEPTR, 7

                        PUSH      _ACCA
                        LDS       _ACCB, MMCLoader.WordsWritten
                        LDS       _ACCA, MMCLoader.WordsWritten+1
                        LDS       _ACCALO, MMCLoader.WordsWritten+2
                        LDS       _ACCAHI, MMCLoader.WordsWritten+3
                        CPI       _ACCAHI, 000h
                        BRNE      MMCLoader._L0163
                        CPI       _ACCALO, 001h
                        BRNE      MMCLoader._L0163
                        CPI       _ACCA, 0F7h
                        BRNE      MMCLoader._L0163
                        CPI       _ACCB, 080h
MMCLoader._L0163:
                        LDI       _ACCA, 0FFh
                        BRLO      MMCLoader._L0164
                        CLR       _ACCA
MMCLoader._L0164:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        TST       _ACCA
                        .BRANCH   3, MMCLoader._L0165
                        BREQ      MMCLoader._L0165
                        .BLOCK    522
                        .LINE     522
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.WRITEPAGE
                        RCALL     MMCLoader.WRITEPAGE
                        ADIW      _FRAMEPTR, 2

                        .LINE     523
                        LDS       _ACCB, MMCLoader.WordsWritten
                        LDS       _ACCA, MMCLoader.WordsWritten+1
                        LDS       _ACCALO, MMCLoader.WordsWritten+2
                        LDS       _ACCAHI, MMCLoader.WordsWritten+3
                        CPI       _ACCAHI, 000h
                        BRNE      MMCLoader._L0168
                        CPI       _ACCALO, 001h
                        BRNE      MMCLoader._L0168
                        CPI       _ACCA, 0F7h
                        BRNE      MMCLoader._L0168
                        CPI       _ACCB, 0FFh
MMCLoader._L0168:
                        .BRANCH   2, MMCLoader._L0160
                        BRSH      MMCLoader._L0160
                        .BRANCH   20,MMCLoader._L0170
                        .BLOCK    523
                        .ENDBLOCK 525
                        .LINE     526
                        LDI       _ACCA, 080h
                        ST        -Y, _ACCA
                        .FRAME  1
                        .FRAME  0
                        .BRANCH   17,MMCLoader.WRITEPAGE
                        RCALL     MMCLoader.WRITEPAGE
                        ADIW      _FRAMEPTR, 2

                        .LINE     527
                        LDS       _ACCB, MMCLoader.WordsWritten
                        LDS       _ACCA, MMCLoader.WordsWritten+1
                        LDS       _ACCALO, MMCLoader.WordsWritten+2
                        LDS       _ACCAHI, MMCLoader.WordsWritten+3
                        CPI       _ACCAHI, 000h
                        BRNE      MMCLoader._L0173
                        CPI       _ACCALO, 001h
                        BRNE      MMCLoader._L0173
                        CPI       _ACCA, 0F7h
                        BRNE      MMCLoader._L0173
                        CPI       _ACCB, 0FFh
MMCLoader._L0173:
                        .BRANCH   2, MMCLoader._L0160
                        BRSH      MMCLoader._L0160
                        RJMP      MMCLoader._L0166
                        .BLOCK    527
                        .ENDBLOCK 529
                        .ENDBLOCK 530
MMCLoader._L0165:
                        .BLOCK    530
                        .LINE     531
                        LDI       _ACCA, 000h
                        .BRANCH   20,MMCLoader.GetCluster_X
                        RJMP      MMCLoader.GetCluster_X
                        .ENDBLOCK 532
MMCLoader._L0166:
                        .LINE     533
                        LDD       _ACCAHI, Y+003h
                        LDD       _ACCALO, Y+002h
                        LDD       _ACCA, Y+001h
                        LDD       _ACCB, Y+000h
                        SUBI      _ACCB, -000000001h AND 0FFh
                        SBCI      _ACCA, -000000001h SHRB 8
                        SBCI      _ACCALO, -000000001h SHRB 16
                        SBCI      _ACCAHI, -000000001h SHRB 24
                        STD       Y+003h, _ACCAHI
                        STD       Y+002h, _ACCALO
                        STD       Y+001h, _ACCA
                        STD       Y+000h, _ACCB
                        .LINE     534
                        MOVW      _ACCCLO, _FRAMEPTR
                        ADIW      _ACCCLO, 000004h
                        LD        _ACCA, Z
                        INC       _ACCA
                        ST        Z, _ACCA
                        .ENDBLOCK 535
                        .LINE     535
                        .BRANCH   20,MMCLoader._L0159
                        RJMP      MMCLoader._L0159
MMCLoader._L0160:
                        .LINE     536
                        LDI       _ACCA, 0FFh
                        .ENDBLOCK 537
MMCLoader.GetCluster_X:
                        .LINE     537
                        .BRANCH   19
                        RET
                        .ENDFUNC  537

                        .INIT_UNIT MMCLoader

                        .BLOCK    540
                        .ENDBLOCK 541
                        .END_UNIT   MMCLoader

                        .FILE     C:\PROJEKTE\MC-HX\SOFTWARE\AVRCO\MC-HX2561\CPULOADER\CPULOADER.pas
                        .UNIT     CPULoader

                        .XDATASTART -1


                        ; ============ user definitions module: CPULoader ============

                        .SYM      gPowerUp, 00530h, 00003h, 3
CPULoader.gPowerUp      .EQU    530h            ; var iData  boolean


                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Program body
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                        .FUNC     $_Main, 00089h, 00020h
                        .ENTRYMAIN $
CPULoader.$_Main:

                        .BLOCK    137
                        .LINE     138
                        IN        _ACCA, MCUSR
                        ANDI      _ACCA, 001h
                        CPI       _ACCA, 001h
                        LDI       _ACCA, 0h
                        BRNE      CPULoader._L0178
                        SER       _ACCA
CPULoader._L0178:
                        STS       CPULOADER.GPOWERUP, _ACCA
                        .LINE     139
                        LDI       _ACCBLO, MCUSR AND 0FFh
                        LDI       _ACCBHI, MCUSR SHRB 8
                        LDI       _ACCA, 000h
                        RCALL     SYSTEM.ExclBit8
                        .LINE     140
                        LDS       _ACCA, CPULoader.gPowerUp
                        COM       _ACCA
                        PUSH      _ACCA
                        IN        _ACCA, MCUSR
                        ANDI      _ACCA, 002h
                        CPI       _ACCA, 002h
                        LDI       _ACCA, 0h
                        BRNE      CPULoader._L0179
                        SER       _ACCA
CPULoader._L0179:
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        TST       _ACCA
                        .BRANCH   3, CPULoader._L0180
                        BREQ      CPULoader._L0180
                        .BLOCK    141
                        .LINE     141
                        LDI       _ACCA, 0FFh
                        STS       CPULOADER.GPOWERUP, _ACCA
                        .ENDBLOCK 142
CPULoader._L0180:
                        .LINE     144
                        LDI       _ACCBLO, MCUCR AND 0FFh
                        LDI       _ACCBHI, MCUCR SHRB 8
                        LDI       _ACCA, 001h
                        RCALL     SYSTEM.InclBit8
                        .LINE     150
                        LDI       _ACCCLO, MMCLoader.BootFlag AND 0FFh
                        LDI       _ACCCHI, MMCLoader.BootFlag SHRB 8
                        ADIW      _ACCCLO, 00004h
                        LDI       _ACCB, 03h
                        OUT       RAMPZ, _ACCB
                        ELPM      _ACCB, Z+
                        ELPM      _ACCA, Z
                        CPI       _ACCA, 0AAh
                        BRNE      CPULoader._L0183
                        CPI       _ACCB, 055h
CPULoader._L0183:
                        LDI       _ACCA, 0h
                        BRNE      CPULoader._L0184
                        SER       _ACCA
CPULoader._L0184:
                        MOV       _ACCB, _ACCA
                        LDS       _ACCA, CPULoader.gPowerUp
                        AND       _ACCA, _ACCB
                        TST       _ACCA
                        .BRANCH   3, CPULoader._L0185
                        BREQ      CPULoader._L0185
                        .BLOCK    151
                        .LINE     151
                        LDI       _ACCBLO, MCUCR AND 0FFh
                        LDI       _ACCBHI, MCUCR SHRB 8
                        LDI       _ACCA, 001h
                        RCALL     SYSTEM.ExclBit8
                        .LINE     152
                        RCALL     SYSTEM.APPLICATION_STARTUP

                        .ENDBLOCK 153
CPULoader._L0185:
                        .LINE     155
                        CLI
                        LDI       _ACCA, 0FEH ROLB IntFlag
                        AND       Flags, _ACCA
                        .LINE     156
                        LDI       _ACCA, 0012Ch SHRB 8
                        LDI       _ACCB, 0012Ch AND 0FFh
                        .FRAME  0
                        RCALL     SYSTEM.MDELAY

CPULoader._L0188:
                        .BLOCK    158
                        .LINE     158
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        .BRANCH   17,MMCLoader.FATINIT
                        RCALL     MMCLoader.FATINIT
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        TST       _ACCA
                        .BRANCH   3,CPULoader._L0188
                        BREQ      CPULoader._L0188
                        .BLOCK    159
                        .LINE     159
                        .BRANCH   17,MMCLoader.GETFILEVERSIONANDCHECKSUM
                        RCALL     MMCLoader.GETFILEVERSIONANDCHECKSUM
                        ADIW      _FRAMEPTR, 16

                        TST       _ACCA
                        .BRANCH   3, CPULoader._L0193
                        BREQ      CPULoader._L0193
                        .BLOCK    160
                        .LINE     160
                        .BRANCH   17,MMCLoader.UPDATEFIRMWARE
                        RCALL     MMCLoader.UPDATEFIRMWARE

                        .ENDBLOCK 161
CPULoader._L0193:
                        .LINE     162
                        LDI       _ACCBLO, MCUCR AND 0FFh
                        LDI       _ACCBHI, MCUCR SHRB 8
                        LDI       _ACCA, 001h
                        RCALL     SYSTEM.ExclBit8
                        .LINE     163
                        RCALL     SYSTEM.APPLICATION_STARTUP

                        .ENDBLOCK 166
                        .ENDBLOCK 167
                        .LINE     167
                        .BRANCH   20,CPULoader._L0188
                        RJMP      CPULoader._L0188
                        .ENDBLOCK 168

CPULoader.$_MAINEX:
                        .LINE     168
                        NOP
                        .LINE     168
                        .BRANCH   20,CPULoader.$_MAINEX
                        RJMP      CPULoader.$_MAINEX


                        .ENDFUNC  168

SYSTEM.$Main_stk        .EQU    00531h          ; var iData  Process stack area
SYSTEM.$Main_stk_e      .EQU    00730h          ; var iData  Process stack area
SYSTEM.$Main_Frame      .EQU    00731h          ; var iData  Process stack area
SYSTEM.$Main_Frame_e    .EQU    00930h          ; var iData  Process stack area

                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Initialisation and Library Routines
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                        .ENTRY
SYSTEM.RESET:
                        LDI       _ACCA, 0
                        OUT       EIND, _ACCA
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        CLI
                        ; >> Stack Init [main process only] <<
                        LDI       _ACCA, 007h
                        LDI       _ACCB, 030h
                        OUT       sph, _ACCA
                        OUT       spl, _ACCB

                        ; External SRAM control
                        LDS       _ACCA, xmcra
                        CBR       _ACCA, 0Fh
; one Peripheral sram-waits
                        SBR       _ACCA, 05h
                        STS       xmcra, _ACCA

                        ; >> Memory init <<
                        CLR       _ACCA
                        LDI       _ACCCLO, 16
                        LDI       _ACCCHI, 0
                        LDI       _ACCBLO, 0
                        LDI       _ACCBHI, 0
                        ADIW      _ACCCLO, 1
                        NOP
SYSTEM._L0196:
                        SBIW      _ACCCLO, 001h
                        BREQ      SYSTEM._L0198
                        ST        X+, _ACCA
                        RJMP      SYSTEM._L0196
SYSTEM._L0198:
                        LDI       _ACCBLO, 00200h AND 0FFh
                        LDI       _ACCBHI, 00200h SHRB 8
                        LDI       _ACCCLO, 02000h AND 0FFh
                        LDI       _ACCCHI, 02000h SHRB 8
                        ADIW      _ACCCLO, 1
                        NOP
SYSTEM._L0199:
                        SBIW      _ACCCLO, 001h
                        BREQ      SYSTEM._L0201
                        ST        X+, _ACCA
                        RJMP      SYSTEM._L0199
SYSTEM._L0201:
                        LDI       _FRAMEPTR, 00930h AND 0FFh
                        LDI       _FPTRHI, 00930h SHRB 8

                        CLI
                        LDI       _ACCA, 0FEH ROLB IntFlag
                        AND       Flags, _ACCA

                        ; ============ init structured constants ============
                        ; >> Hardware Init <<

                        CLR       Flags
                        CLR       Flags2

                        ; ============ Unit Initialization ============

                        ; activate Boot Vectors
                        IN        _ACCB, MCUCR
                        SBR       _ACCB, 03h
                        OUT       MCUCR, _ACCB
                        CBR       _ACCB, 01h
                        OUT       MCUCR, _ACCB

                        ; ============ Start User Main Program ============

                        .DEB      MAINENTRY
                        RJMP      CPULoader.$_Main

                        ; ============ Interrupt Service ============


                        ; ============ Library ============


SYSTEM._L0203:
                        ELPM      _ACCGLO, Z+
                        ADD       _ACCALO, _ACCGLO
                        ADC       _ACCAHI, _ACCEHI
                        SBIW      _ACCBLO, 01h
                        BRNE       SYSTEM._L0203
                        IN        _ACCB, RAMPZ
                        TST       _ACCA
                        BREQ     SYSTEM._L0205
                        CLR       _ACCB
                        ELPM      _ACCBLO, Z+
                        ELPM      _ACCBHI, Z+
                        CP        _ACCBLO, _ACCALO
                        CPC       _ACCBHI, _ACCAHI
                        BREQ       SYSTEM._L0204
                        INC       _ACCA
SYSTEM._L0204:
                        CLR       _ACCCLO
                        CLR       _ACCCHI
                        CLR       _ACCALO
                        CLR       _ACCAHI
SYSTEM._L0205:
                        STS       _CalcFlashPage, _ACCB
                        LDI       _ACCB, 03h
                        OUT       RAMPZ, _ACCB
                        SBRC      Flags, IntFlag
                        SEI
                        STS       _CalcFlashAddr, _ACCCLO
                        STS       _CalcFlashAddr+1, _ACCCHI
                        STS       _CalcFlashCS, _ACCALO
                        STS       _CalcFlashCS+1, _ACCAHI
                        RET

SYSTEM.MDELAY:
                        .DEB      DEBdelay
                        MOVW      _ACCDLO, _ACCB
                        CLR       _ACCA
                        CP        _ACCDLO, _ACCA
                        CPC       _ACCDHI, _ACCA
                        BREQ      SYSTEM.MDELAY3
SYSTEM.MDELAY1:
                        LDI       _ACCB, 00B7Fh AND 0FFh
                        LDI       _ACCA, 00B7Fh SHRB 8
SYSTEM.MDELAY2:
                        SUBI      _ACCB, 001h
                        SBCI      _ACCA, 000h
                        NOP
                        BRNE      SYSTEM.MDELAY2
                        SUBI      _ACCDLO, 001h
                        SBCI      _ACCDHI, 000h
                        BRNE      SYSTEM.MDELAY1
SYSTEM.MDELAY3:
                        RET

SYSTEM.Application_Startup:
                        CLI
                        ; disable Boot Vectors
                        IN        _ACCB, MCUCR
                        CBR       _ACCB, 02h
                        SBR       _ACCB, 01h
                        OUT       MCUCR, _ACCB
                        CBR       _ACCB, 01h
                        OUT       MCUCR, _ACCB
                        JMP       $0000
SYSTEM._L0206:
                        SUBI      _ACCALO, 001h
                        SBCI      _ACCAHI, 000h
                        BRCS      SYSTEM._L0207
                        LD        _ACCA, Z+
                        ST        X+, _ACCA
                        RJMP      SYSTEM._L0206
SYSTEM._L0207:
                        RET


SYSTEM.MUL32:
                        MOVW      _ACCBLO, _ACCB
                        MOVW      _ACCCLO, _ACCALO
                        POP       _ACCFHI
                        POP       _ACCA
                        POP       _ACCB
                        POP       _ACCEHI
                        POP       _ACCELO
                        POP       _ACCDHI
                        POP       _ACCDLO
                        PUSH      _ACCB
                        PUSH      _ACCA
                        PUSH      _ACCFHI
                        RJMP      SYSTEM._L0208
SYSTEM.MUL32_R:
                        MOVW      _ACCBLO, _ACCB
                        MOVW      _ACCCLO, _ACCALO
SYSTEM._L0208:
                        BST       Flags, _SIGN
                        BRTC      SYSTEM._L0209
                        MOV       _ACCFLO, _ACCCHI
                        EOR       _ACCFLO, _ACCEHI
                        CLT
                        SBRS      _ACCFLO, 7
                        BLD       Flags, _SIGN
                        SBRS      _ACCCHI, 7
                        RJMP      SYSTEM._L0211
                        COM       _ACCBLO
                        COM       _ACCBHI
                        COM       _ACCCLO
                        COM       _ACCCHI
                        SUBI      _ACCBLO, 0FFh
                        SBCI      _ACCBHI, 0FFh
                        SBCI      _ACCCLO, 0FFh
                        SBCI      _ACCCHI, 0FFh
SYSTEM._L0211:
                        SBRS      _ACCEHI, 7
                        RJMP      SYSTEM._L0209
                        COM       _ACCDLO
                        COM       _ACCDHI
                        COM       _ACCELO
                        COM       _ACCEHI
                        SUBI      _ACCDLO, 0FFh
                        SBCI      _ACCDHI, 0FFh
                        SBCI      _ACCELO, 0FFh
                        SBCI      _ACCEHI, 0FFh
SYSTEM._L0209:
                        CLR       _ACCFHI
                        CLR       _ACCFLO
                        CLR       _ACCGHI
                        CLR       _ACCGLO
                        LDI       _ACCA, 32
                        LSR       _ACCEHI
                        ROR       _ACCELO
                        ROR       _ACCDHI
                        ROR       _ACCDLO
SYSTEM._L0213:
                        BRCC      SYSTEM._L0212
                        ADD       _ACCFLO, _ACCBLO
                        ADC       _ACCFHI, _ACCBHI
                        ADC       _ACCGLO, _ACCCLO
                        ADC       _ACCGHI, _ACCCHI
SYSTEM._L0212:
                        ROR       _ACCGHI
                        ROR       _ACCGLO
                        ROR       _ACCFHI
                        ROR       _ACCFLO
                        ROR       _ACCEHI
                        ROR       _ACCELO
                        ROR       _ACCDHI
                        ROR       _ACCDLO
                        DEC       _ACCA
                        BRNE      SYSTEM._L0213
                        MOVW      _ACCB, _ACCDLO
                        MOVW      _ACCALO, _ACCELO
                        MOVW      _ACCDLO, _ACCGLO
                        BST       Flags, _SIGN
                        BRTC      SYSTEM._L0210
                        SUBI      _ACCB, 01h
                        SBCI      _ACCA, 00h
                        SBCI      _ACCALO, 00h
                        SBCI      _ACCAHI, 00h
                        SBCI      _ACCFLO, 00h
                        SBCI      _ACCFHI, 00h
                        SBCI      _ACCDLO, 00h
                        SBCI      _ACCDHI, 00h
                        COM       _ACCALO
                        COM       _ACCAHI
                        COM       _ACCA
                        COM       _ACCB
                        COM       _ACCFLO
                        COM       _ACCFHI
                        COM       _ACCDLO
                        COM       _ACCDHI
SYSTEM._L0210:
                        RET



SYSTEM.DIV32_R:
                        CLR       _ACCA
                        BST       Flags, _SIGN
                        BRTC      SYSTEM.DIV32_U
                        MOV       _ACCA, _ACCEHI
                        MOV       _ACCFLO, _ACCCHI
                        EOR       _ACCFLO, _ACCEHI
                        CLT
                        SBRS      _ACCFLO, 7
                        BLD       Flags, _SIGN
                        SBRS      _ACCCHI, 7
                        RJMP      SYSTEM._L0214
                        COM       _ACCBLO
                        COM       _ACCBHI
                        COM       _ACCCLO
                        COM       _ACCCHI
                        SUBI      _ACCBLO, 0FFh
                        SBCI      _ACCBHI, 0FFh
                        SBCI      _ACCCLO, 0FFh
                        SBCI      _ACCCHI, 0FFh
SYSTEM._L0214:
                        SBRS      _ACCEHI, 7
                        RJMP      SYSTEM.DIV32_U
                        COM       _ACCDLO
                        COM       _ACCDHI
                        COM       _ACCELO
                        COM       _ACCEHI
                        SUBI      _ACCDLO, 0FFh
                        SBCI      _ACCDHI, 0FFh
                        SBCI      _ACCELO, 0FFh
                        SBCI      _ACCEHI, 0FFh
SYSTEM.DIV32_U:
                        PUSH      _ACCA
                        CLR       _ACCFLO
                        CLR       _ACCFHI
                        CLR       _ACCGLO
                        CLR       _ACCGHI
                        LDI       _ACCA, 33
SYSTEM._L0216:
                        ROL       _ACCDLO
                        ROL       _ACCDHI
                        ROL       _ACCELO
                        ROL       _ACCEHI
                        DEC       _ACCA
                        BRNE      SYSTEM._L0215
                        MOVW      _ACCB, _ACCDLO
                        MOVW      _ACCALO, _ACCELO
                        BST       Flags, _SIGN
                        BRTC      SYSTEM._L0218
                        SUBI      _ACCB, 01h
                        SBCI      _ACCA, 00h
                        SBCI      _ACCALO, 00h
                        SBCI      _ACCAHI, 00h
                        COM       _ACCALO
                        COM       _ACCAHI
                        COM       _ACCA
                        COM       _ACCB
SYSTEM._L0218:
                        POP       _ACCDHI
                        RET
SYSTEM._L0215:
                        ROL       _ACCFLO
                        ROL       _ACCFHI
                        ROL       _ACCGLO
                        ROL       _ACCGHI
                        SUB       _ACCFLO, _ACCBLO
                        SBC       _ACCFHI, _ACCBHI
                        SBC       _ACCGLO, _ACCCLO
                        SBC       _ACCGHI, _ACCCHI
                        BRCC      SYSTEM._L0217
                        ADD       _ACCFLO, _ACCBLO
                        ADC       _ACCFHI, _ACCBHI
                        ADC       _ACCGLO, _ACCCLO
                        ADC       _ACCGHI, _ACCCHI
                        CLC
                        RJMP      SYSTEM._L0216
SYSTEM._L0217:
                        SEC
                        RJMP      SYSTEM._L0216


SYSTEM.InclBit8:
                        ANDI      _ACCA, 7
                        LDI       _ACCCLO, SYSTEM.BitMaskTab AND 0FFh
                        LDI       _ACCCHI, SYSTEM.BitMaskTab SHRB 8
                        CLR       _ACCGLO
                        ADD       _ACCCLO, _ACCA
                        ADC       _ACCCHI, _ACCGLO
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM
                        LD        _ACCA, X
                        OR        _ACCA, _ACCGLO
                        ST        X, _ACCA
                        RET


SYSTEM.ExclBit8:
                        ANDI      _ACCA, 7
                        LDI       _ACCCLO, SYSTEM.BitMaskTab AND 0FFh
                        LDI       _ACCCHI, SYSTEM.BitMaskTab SHRB 8
                        CLR       _ACCGLO
                        ADD       _ACCCLO, _ACCA
                        ADC       _ACCCHI, _ACCGLO
                        LDI       _ACCA, 03h
                        OUT       RAMPZ, _ACCA
                        ELPM
                        COM       _ACCGLO
                        LD        _ACCA, X
                        AND       _ACCA, _ACCGLO
                        ST        X, _ACCA
                        RET

SYSTEM.FLASHERASEPAGE:
                        CLI
                        LDS       _ACCCHI, FLASH_ADDR+1
                        LDS       _ACCCLO, FLASH_ADDR
                        LDS       _ACCA, FLASH_PAGE
                        OUT       RAMPZ, _ACCA
                        RCALL     SYSTEM._FlashWaitRdy
                        LDI       _ACCA, 3
                        OUT       SPMCR, _ACCA
                        SPM
                        RCALL     SYSTEM._FlashWaitRdy
                        LDI       _ACCA, 17
                        OUT       SPMCR, _ACCA
                        SPM
                        LDI       _ACCB, 03h
                        OUT       RAMPZ, _ACCB
                        SBRC      Flags, IntFlag
                        SEI
                        RET

SYSTEM.FLASHWRITEPAGE:
                        CLI
                        MOVW      0, _ACCB
                        LDS       _ACCCHI, FLASH_ADDR+1
                        LDS       _ACCCLO, FLASH_ADDR
                        ANDI      _ACCCLO, 0FEh
                        LDS       _ACCA, FLASH_PAGE
                        OUT       RAMPZ, _ACCA
                        RCALL     SYSTEM._FlashWaitRdy
                        LDI       _ACCA, 1
                        OUT       SPMCR, _ACCA
                        SPM
                        ADIW      _ACCCLO, 2
                        STS       FLASH_ADDR+1, _ACCCHI
                        STS       FLASH_ADDR, _ACCCLO
                        LDI       _ACCB, 03h
                        OUT       RAMPZ, _ACCB
                        SBRC      Flags, IntFlag
                        SEI
                        RET

SYSTEM.FLASHPROGPAGE:
                        CLI
                        LDS       _ACCCHI, FLASH_ADDR+1
                        LDS       _ACCCLO, FLASH_ADDR
                        ANDI      _ACCCLO, 000h
                        LDS       _ACCA, FLASH_PAGE
                        OUT       RAMPZ, _ACCA
                        RCALL     SYSTEM._FlashWaitRdy
                        LDI       _ACCA, 5
                        OUT       SPMCR, _ACCA
                        SPM
                        RCALL     SYSTEM._FlashWaitRdy
                        LDI       _ACCA, 17
                        OUT       SPMCR, _ACCA
                        SPM
                        LDI       _ACCB, 03h
                        OUT       RAMPZ, _ACCB
                        SBRC      Flags, IntFlag
                        SEI
                        RET

SYSTEM._FlashWaitRdy:
                        sbic      EECR, 1;
                        rjmp      SYSTEM._FlashWaitRdy
                        IN        _ACCA, SPMCR
                        SBRC      _ACCA, 0
                        RJMP      SYSTEM._FlashWaitRdy
                        RET

SYSTEM.DefIntErr:
                        RETI


                        .ROMCONST $

SYSTEM.BitMaskTab:
                        .BYTE     001h
                        .BYTE     002h
                        .BYTE     004h
                        .BYTE     008h
                        .BYTE     010h
                        .BYTE     020h
                        .BYTE     040h
                        .BYTE     080h

                        ; ============ String-constant tables ============
                        .SYM      MMCLoader.UPDNAME
MMCLoader.UPDNAME:
                        .BYTE     8
                        .ASCII    "CPU     "


                        ; ============ record-constant tables ============

                        ; ============ Fixed addr String-constant tables ============

                        ; ============ fixed addr array-constant tables ============

                        ; ============ fixed addr record-constant tables ============
MMCLoader.BootFlag        .EQU          3EFF8h
                        .ORG      3FFF8h
                        .CONST    2
                        .WORD     00000h
                        .WORD     00004h
                        .WORD     0BB66h


                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Reset and Interrupt vectors
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


                        .ENDCODE
                        .ORG       03F000h, VECTTAB
                        .ENTRYBOOT $
                        .VECTTAB
                        JMP       SYSTEM.RESET
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr
                        JMP       SYSTEM.DefIntErr

                        .VECTTABE
                        .FLASHCHECK  3FFFEh

                        .END

                        ; ============ End of Program ============


                        ; System uses registers
                        ; from bottom     = 00000h
                        ; upto            = 00005h
                        ; and
                        ; from            = 00010h
                        ; upto            = 0001Fh
                        ;
                        ; Stackframe at   = ...00730h


                        ; ===== Current top of User Vars in Data is 00005h =====

                        ; ===== Current top of User Vars in IData is 00930h =====

                        ; ===== EEprom currently not used =====


                        ; ===== Imported Library Routines =====

                        ; LongWord and LongInt types
                        ; Multiply     long MUL32
                        ; Divide       long DIV32
                        ; InclBit8
                        ; ExclBit8

                        ; Pascal Statements : 220
                        ; Assembler Lines   : 8121
                        ; Optimizer removed : 549 lines = 1098Bytes

                        

                                  
                        ; Merlin Optimiser Version 3.1.1.3 saved 1352 bytes.
                        ; Original size was 5364 so % saved = 25%
                        ; Elapsed Time (hh:mm:ss) : 00:00:00
